function [ Ckt ] = Ckt_Gen2( Ckt, Fresp, MIX, ...
    Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

Ckt.NumV = length( Ckt.CharCEL_Vdep );
%% ########################### CharCEL => SYM_[Ymat/ILIN/  INLvdep],  SYM_[R/gNL/  zBD.(Z)],  SYM_[A]
if(Opt_Disp)
    disp([ '%########################### Ckt.SYM_[Ymat, ILIN, Vdep, Vsrc, R, ZBD.(Z)]' ])
end
%========================================================== Lin
%[ Ckt.SYM_Vdep ]	= CHARcel2SYMmat( Ckt.CharCEL_Vdep ).';
%[ Ckt.SYM_Vsrc ]	= CHARcel2SYMmat( Ckt.CharCEL_Vsrc ).';
%---------------------------------------------------------- usable as SymCEL
[ Ckt.SYM_Ymat ]    = CHARcel2SYMmat( Ckt.CharCEL_Ymat );
[ Ckt.SYM_ILIN ]    = CHARcel2SYMmat( Ckt.CharCEL_ILIN ).';
%-------------------------- SYM_R
[ Ckt.SYM_R ]       = mat2cell( CHARcel2SYMmat( Ckt.CharCEL_R ), ...
                                ones(1,size(Ckt.CharCEL_R,1)), ...
                                ones(1,size(Ckt.CharCEL_R,2)) );
%-------------------------- SYM_ZBD
for nz = 1 : length( Ckt.CharCEL_Z )
    Z = Ckt.CharCEL_Z{ nz };
for nBD = 1 : length( MIX.fmix_BD )
for nmixBD = 1 : size( MIX.fmix_BD{nBD},1 )
    Ckt.SYM_ZBD.( Z ){nBD}(nmixBD,:) = { sym([Z  MIX.fmixCHAR_BD{nBD}{nmixBD,1}])	sym([Z  MIX.fmixCHAR_BD{nBD}{nmixBD,2}]) };
end
end
end
%========================================================== NL
%-------------------------- SYM_INLvdep
for nV = 1 : Ckt.NumV
for nL = 1 : length( Ckt.INL_Vdep_type{nV} )
for k = 1 : size( Ckt.INL_Vdep{nV}, 1 )
if ~isempty( Ckt.INL_Vdep{nV}{k,nL} )
    Ckt.SYM_INLvdep{nV}{k,nL} = sym( Ckt.INL_Vdep{nV}{k,nL} );
else
    Ckt.SYM_INLvdep{nV}{k,nL} = [];% sym( [] )
end
end
end
end
%-------------------------- SYM_gNL
    Ckt.SYM_gNL = struct;
for nV = 1 : Ckt.NumV
for nL = 1 : length( Ckt.INL_Vdep_type{nV} )
    gNL = Ckt.INL_Vdep_gNL{nV}{nL};
if ~isfield( Ckt.SYM_gNL, gNL )
switch Ckt.INL_Vdep_type{nV}{nL}
	%--------------------------------------------
	case{'multiply'}% mixer
        Ckt.SYM_gNL.( gNL )(2) = sym( [gNL] );
	%--------------------------------------------
	case{'poly','capNL','indNL'}% gm, capNL, indNL
        for r = 2 : MIX.N
            switch Ckt.INL_Vdep_eo{nV}{nL}
                case{'eo'}
                    Ckt.SYM_gNL.( gNL )(r) = sym( [gNL	'_' num2str(r)] );
                case{'e'}
                    if IsEven_Func( r )
                        Ckt.SYM_gNL.( gNL )(r) = sym( [gNL	'_' num2str(r)] );
                    end
                case{'o'}
                    if ~IsEven_Func( r )
                        Ckt.SYM_gNL.( gNL )(r) = sym( [gNL	'_' num2str(r)] );
                    end
            end
        end
	%--------------------------------------------
end
end
end
end
% SYM_gNL_FLAG
%========================================================== Mtone Source
for q = 1 : Ckt.Q
    Ckt.SYM_A(q,:)	= { sym(['A' num2str(q)])	sym(['A' num2str(q) '_']) };
end

%% ########################### Soln.( Vdep, Vsrc )
if(Opt_Disp)
    disp([ '%########################### Ckt.Soln( Vdep )' ])
end
    Vdep1               = Ckt.CharCEL_Vdep{1};
    Ckt.Soln.( Vdep1 )	= Soln_Init( Fresp );
for nV = 2 : Ckt.NumV
    Vdep                = Ckt.CharCEL_Vdep{ nV };
    Ckt.Soln.( Vdep )	= Ckt.Soln.( Vdep1 );% Soln_Init( Fresp )
end
for nSRC = 1 : length( Ckt.CharCEL_Vsrc )
    Vsrc                = Ckt.CharCEL_Vsrc{ nSRC };
    Ckt.Soln.( Vsrc )	= Ckt.Soln.( Vdep1 );% Soln_Init( Fresp )
end

if(Opt_Disp)
    disp([ '%########################### Ckt.Soln.( Vsrc )' ])
end
for n = 1 : 1
for nmixRCD = 1 : length( Ckt.CharCEL_VsrcTone )
    %--------------------------
    [ nSRC	xXORy_IDX	yVEC_IDX	yXORy_IDX] = Find_VecIDX_Func(...
            Ckt.CharCEL_Vsrc, ...
            Ckt.CharCEL_VsrcTone( nmixRCD ), 'VECTOR', [], 0);
    Vsrc	= Ckt.CharCEL_Vsrc{ nSRC };
    Ckt.Soln.( Vsrc ){n}{nmixRCD,1} = Ckt.SYM_A{nmixRCD,1};% / 2
    Ckt.Soln.( Vsrc ){n}{nmixRCD,2} = Ckt.SYM_A{nmixRCD,2};% / 2
    %--------------------------
    if(Opt_Disp)
        disp([Vsrc '{' num2str(n) '}{' num2str(nmixRCD) ':}' ])
        Ckt.Soln.( Vsrc ){n}{nmixRCD,:}% DEBUG
    end
    %--------------------------
end
end

if(Opt_Disp)
    Ckt.Soln% DEBUG
end

%% ****************************************************
function [ V ] = Soln_Init( Fresp )

for n = 1 : length( Fresp.fmixFLAG_RCD )
for nmixRCD = 1 : size( Fresp.fmixFLAG_RCD{n},1 )
	%riVEC	= Fresp.fmixFLAG_RCD{n}(nmixRCD,:);
for nRI = 1 : 2% length( riVEC )
    %if ~(riVEC(nRI) == 0)
        V{n}{nmixRCD,nRI} = sym('0');
    %end
end
end
end
