function [ Ckt ] = Ckt_SolnNL3( Ckt, Fresp, ...
    F, MIX, Wnr, ...
    Opt_Disp )
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end
    
Fresp.fmixFLAG_RCD3 = {};% indicator of path traveled {n,1}{nMIX,:} = [R I] 
    Fresp.fmixFLAG_RCD3{1} = Fresp.fmixFLAG_RCD{1};% LinSoln computed already
%% ########################### NL-Soln:    Ckt.Soln.( Vdep ){n}{nRESP,nRI}
for nRESP = 1 : size( Fresp.fRESP,1 )
    %nBD     = Fresp.IdxBD(nRESP,1);
    %nMIX_BD = Fresp.IdxBD(nRESP,2);
    %Fresp.IdxRCD{ nRESP } = MIX.IdxRCD_BD{nBD}{nMIX_BD};
        if(Opt_Disp)
            disp(['%############################################################## nRESP=' num2str(nRESP)])
            Fresp.IdxRCD{ nRESP }%DEBUG
        end
%---------------------------------------------------- 
for nn = 1 : size( Fresp.IdxRCD{ nRESP },1 )
    n      	= Fresp.IdxRCD{ nRESP }(nn,1);
    nmix	= Fresp.IdxRCD{ nRESP }(nn,2);
    nri     = 1;% for measured
        if(Opt_Disp)
            disp(['%#############################[nRESP n]=' num2str([nRESP  n])])
            MIX.fmixSYM_RCD{n}(nmix)%fmix DEBUG
            % F{n}{nmix, nri}
        end
    Fresp.fmixFLAG_RCD3{n} = zeros(size( MIX.fmix_RCD{n} ));% Initialize
    %---------------------- Fresp.fmixFLAG_RCD
	%isequal(Ckt.Soln.( Ckt.CharCEL_Vdep{1} ){n}(nmix, nri), sym('0'))
    if(Fresp.fmixFLAG_RCD3{n}(nmix, nri) == 0)% if path not traveled
        [ Ckt	Fresp ] = Recur( n, nmix, nri, ...
            Ckt, Fresp, F, MIX, Wnr, Opt_Disp);
        %Fresp.fmixFLAG_RCD3{n}(nmix, nri) = 1;% indicate path was traveled
    end
%---------------------------------------------------- 
end
end

%% **************************************************** F{n}{nmix, nri}
function [ Ckt	Fresp ] = Recur( n, nmix, nri, ...
    Ckt, Fresp, F, MIX, Wnr, ...
    Opt_Disp)
if(Opt_Disp)  disp(['%############################################[n, nmix, nri] ' num2str([n, nmix, nri])]); end
riFCT  = [1 -1];

if(n == 1)
%=================================================================
    % LinSoln computed already
%=================================================================
else%(n > 1)
	INL_VEC	= sym(zeros( Ckt.NumV,1 ));% (nV)
%#################################################### calc INL_VEC
FlagPOLY = 0;% set once b.c FuncCall find INL(gm, capNL, indNL) simultaneously 
for nTYPE = 1 : length( Ckt.INL_types )
	switch Ckt.INL_types{nTYPE}
        %--------------------------------------------
        case{'poly','capNL','indNL'}% gm, capNL, indNL
        if( FlagPOLY == 0 )
            [ INLpoly_VEC  INLcap_VEC ] = Poly( n, nmix, nri, ...
                Ckt, Fresp, F, MIX, Wnr, 1);
            INL_VEC	= INL_VEC + INLpoly_VEC + INLcap_VEC;
            FlagPOLY = 1;% set once b.c FuncCall find INL(gm, capNL, indNL) simultaneously 
        end
        %--------------------------------------------
        case{'multiply'}% mixer
            [ INLmult_VEC ] = Multiply( n, nmix, nri, ...
                Ckt, Fresp, F, MIX, Wnr, 1);
            INL_VEC	= INL_VEC + INLmult_VEC;
        %--------------------------------------------
        otherwise
            disp('unknown Ckt.INL_types');
    end
end
%#################################################### calc V_VEC
    %nBD    = Fresp.fmixFLAG_RCD{n,2}(nmix,1);
    %nMIX   = Fresp.fmixFLAG_RCD{n,2}(nmix,2);
    nBD     = MIX.IdxBD_RCD{n}(nmix,1);
    nMIX    = MIX.IdxBD_RCD{n}(nmix,2);
Z_CEL	= {};
    for nz = 1 : length( Ckt.CharCEL_Z )
        Z        	= Ckt.CharCEL_Z{ nz };
        Z_CEL{ nz }	= Ckt.SYM_ZBD.( Z ){nBD}{nMIX,nri};
    end
Ymat	= subs( Ckt.SYM_Ymat, ...
        {Ckt.CharCEL_Z{:}   's'}, ...
        {Z_CEL{:}           j*2*pi * riFCT(nri) * MIX.fmixSYM_RCD{n}(nmix)} );
V_VEC	= Ymat \ INL_VEC;
    for nV = 1 : Ckt.NumV
        Vdep	= Ckt.CharCEL_Vdep{ nV };
        Ckt.Soln.( Vdep ){n}{nmix,nri} = V_VEC(nV);
    end
%#################################################### 
    % indicate path was traveled
%=================================================================
end

    Fresp.fmixFLAG_RCD3{n}(nmix, nri) = 1;% indicate path was traveled
return
%% ######################################################
function [ INLpoly_VEC  INLcap_VEC ] = Poly( n, nmix, nri, ...
    Ckt, Fresp, F, MIX, Wnr, ...
    Opt_Disp)
INLpoly_VEC	= sym(zeros( Ckt.NumV,1 ));% (nV)
INLcap_VEC	= sym(zeros( Ckt.NumV,1 ));% (nV)
riFCT       = [1 -1];

for r = 2 : length( F{n}{nmix, nri}.wnr )
    if(Opt_Disp)  disp(['%============================================[r] ' num2str([r])]); end
Ir_VEC      = sym(zeros( Ckt.NumV,1 ));% (nV)
Vr_VecCEL	= Vrc_Init( 0, 1, Ckt.CharCEL_Vdep );% {1,nV}{nL}
Vc_MatCEL	= Vrc_Init( 0, size( Wnr.PolyOrd_MAT{n,r}, 1 ), Ckt.CharCEL_Vdep );% {rC,nV}{nL}
Ir_VEC_CAP   	= Ir_VEC;
Vr_VecCEL_CAP	= Vr_VecCEL;
Vc_MatCEL_CAP	= Vc_MatCEL;
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )
    if(Opt_Disp)  disp(['%--------------------------------------------[rC] ' num2str([rC])]); end
	PolyOrd_VEC         = Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = F{n}{ nmix,nri }.wnr{r}{rC,1};
    PolyOrd_riMAT       = F{n}{ nmix,nri }.wnr{r}{rC,2};
    if(Opt_Disp)
        PolyOrd_VEC% DEBUG
        PolyOrd_nMIXMAT% DEBUG
        PolyOrd_riMAT% DEBUG
    end
Vrc_MatCEL      = Vrc_Init( 1, size( PolyOrd_nMIXMAT,1), Ckt.CharCEL_Vdep );% {rMIX,nV}{nL}
Vrc_MatCEL_CAP	= Vrc_MatCEL;
for rMIX = 1 : size( PolyOrd_nMIXMAT,1)
    if(Opt_Disp)  disp(['%---------------------------------[rMIX] ' num2str([rMIX])]); end
for k = 1 : length( PolyOrd_VEC )
    if(Opt_Disp)  disp(['%----------------------[k] ' num2str([k])]); end
	Ord_k	= PolyOrd_VEC(           k);
    Mix_k	= PolyOrd_nMIXMAT(	rMIX,k);
    ri_k    = PolyOrd_riMAT(    rMIX,k);
        if(ri_k == -1)
            ri_k = 2;
        end
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ calc Vdep (must call bc NonEmpty iNL)
if( Fresp.fmixFLAG_RCD3{Ord_k}(Mix_k, ri_k) == 0)% if path not traveled
    [ Ckt	Fresp ] = Recur( Ord_k, Mix_k, ri_k, ...
        Ckt, Fresp, F, MIX, Wnr, Opt_Disp);
    %Fresp.fmixFLAG_RCD3{Ord_k}(Mix_k, ri_k) = 1;% indicate path was traveled
end
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ calc INL
for nV = 1 : Ckt.NumV
for nL = 1 : length( Ckt.INL_Vdep{nV} )% effectively take care of empty ~isempty(Ckt.SYM_INLvdep{nV}{nL})
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
if ~isempty( Ckt.SYM_INLvdep{nV}{nL} )
    Vdep_CEL = {};
    Vsrc_CEL = {};
    for nIDX = 1 : length( Ckt.INL_Vdep_SymCEL{nV}{nL} )
        Vdep_IDX        = Ckt.INL_Vdep_IDX{nV}{nL}(nIDX);
        Vdep            = Ckt.CharCEL_Vdep{ Vdep_IDX };
        Vdep_CEL{nIDX}	= Ckt.Soln.( Vdep ){Ord_k}{Mix_k,ri_k};
    end
    for nIDX = 1 : length( Ckt.INL_Vsrc_SymCEL{nV}{nL} )
        Vsrc_IDX        = Ckt.INL_Vsrc_IDX{nV}{nL}(nIDX);
        Vsrc            = Ckt.CharCEL_Vsrc{ Vsrc_IDX };
        Vsrc_CEL(nIDX)	= Ckt.Soln.( Vsrc ){Ord_k}{Mix_k,ri_k};        
    end
    if(Opt_Disp)
        %[ Vdep_CEL{:} ]% DEBUG
        %[ Vsrc_CEL{:} ]% DEBUG
    end
    Vtemp = subs( Ckt.SYM_INLvdep{nV}{nL}, ...
         	{Ckt.INL_Vdep_SymCEL{nV}{nL}{:}     Ckt.INL_Vsrc_SymCEL{nV}{nL}{:}}, ...
            {Vdep_CEL{:}                        Vsrc_CEL{:}} );
	%Ckt.SYM_INLvdep{nV}{nL}% DEBUG subs
	%Vtemp% DEBUG subs% DEBUG subs
        switch Ckt.INL_Vdep_type{nV}{nL}
            case{'poly'}
                Vrc_MatCEL{rMIX,nV}{nL}     = Vrc_MatCEL{rMIX,nV}{nL}     * Vtemp;
            case{'capNL'}
                Vrc_MatCEL_CAP{rMIX,nV}{nL} = Vrc_MatCEL_CAP{rMIX,nV}{nL} * Vtemp;
            otherwise
                disp('unknown Ckt.INL_Vdep_type');
        end
end
%~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
end
end
%@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@	 
end%----------------------[k]                           Vrc_MatCEL
    for nV = 1 : Ckt.NumV
    for nL = 1 : length( Ckt.INL_Vdep{nV} )
        switch Ckt.INL_Vdep_type{nV}{nL}
            case{'poly'}
                Vc_MatCEL{rC,nV}{nL}     = Vc_MatCEL{rC,nV}{nL}     + Vrc_MatCEL{rMIX,nV}{nL};
            case{'capNL'}
                Vc_MatCEL_CAP{rC,nV}{nL} = Vc_MatCEL_CAP{rC,nV}{nL} + Vrc_MatCEL_CAP{rMIX,nV}{nL};
            otherwise
                disp('unknown Ckt.INL_Vdep_type');
        end
    end
    end
end%---------------------------------[rMIX]             Vc_MatCEL
    for nV = 1 : Ckt.NumV
    for nL = 1 : length( Ckt.INL_Vdep{nV} )
        switch Ckt.INL_Vdep_type{nV}{nL}
            case{'poly'}
                Vc_MatCEL{rC,nV}{nL}     = Vc_MatCEL{rC,nV}{nL}     * Wnr.c_VEC{n,r}(rC);
            case{'capNL'}
                Vc_MatCEL_CAP{rC,nV}{nL} = Vc_MatCEL_CAP{rC,nV}{nL} * Wnr.c_VEC{n,r}(rC);
            otherwise
                disp('unknown Ckt.INL_Vdep_type');
        end
    end
    end
    for nV = 1 : Ckt.NumV
    for nL = 1 : length( Ckt.INL_Vdep{nV} )
        switch Ckt.INL_Vdep_type{nV}{nL}
            case{'poly'}
                Vr_VecCEL{1,nV}{nL}     = Vr_VecCEL{1,nV}{nL}     + Vc_MatCEL{rC,nV}{nL};
            case{'capNL'}
                Vr_VecCEL_CAP{1,nV}{nL}	= Vr_VecCEL_CAP{1,nV}{nL} + Vc_MatCEL_CAP{rC,nV}{nL};
            otherwise
                disp('unknown Ckt.INL_Vdep_type');
        end
    end
    end
end%--------------------------------------------[rC]     Vr_VecCEL
    for nV = 1 : Ckt.NumV
        %if(0) disp(['%########## nV=' num2str(nV)]); end
    for nL = 1 : length( Ckt.INL_Vdep{nV} )
        %if(0) disp(['%########## nL=' num2str(nL)]); end
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        if ~isempty( Ckt.INL_gNL_IDX{nV}{nL} )% && ~isempty( Vr_VecCEL{1,nV}{nL})
            gNL 	= Ckt.INL_gNL_IDX{nV}{nL};
            gNL_r   = Ckt.SYM_gNL.( gNL )(r);
            if(0)%disp('OK')
                %Ir_VEC(nV)
                %Vr_VecCEL{1,nV}{nL}
            end
            switch Ckt.INL_Vdep_type{nV}{nL}
                case{'poly'}
                    Ir_VEC(nV)      = Ir_VEC(nV)    + gNL_r * Vr_VecCEL{1,nV}{nL};
                case{'capNL'}
                    Ir_VEC_CAP(nV)	= Ir_VEC_CAP(nV) + gNL_r/r * Vr_VecCEL_CAP{1,nV}{nL};
                otherwise
                    disp('unknown Ckt.INL_Vdep_type');
            end
        end
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    end
    end
    INLpoly_VEC = INLpoly_VEC   + Ir_VEC;
    INLcap_VEC  = INLcap_VEC    + Ir_VEC_cap;
end%============================================[r]     Ir_VEC --> INLpoly_VEC
    INLcap_VEC  = INLcap_VEC    * (j*2*pi * riFCT(nri) * MIX.fmixSYM_RCD{n}(nmix));

return
%% ########################### 
function [ Vrc_MatCEL ] = Vrc_Init( const, NumMIX, CharCEL_INLvdep )

for rMIX = 1 : NumMIX
for nV = 1 : length( CharCEL_INLvdep )
for nL = 1 : length( CharCEL_INLvdep{nV} )
    Vrc_MatCEL{rMIX,nV}{nL} = sym( num2str(const) );
end
end
end

return
%% ########################### Scrap
if(0)
    
%CharCEL_Vdep = {};
        %if ~isempty( Ckt.Soln.( Vdep ){Ord_k}{Mix_k,ri_k} )
        %    CharCEL_Vdep	= { CharCEL_Vdep{:} Ckt.CharCEL_Vdep{nV} };
        %    Vdep_CEL     	= { Vdep_CEL{:}     Ckt.Soln.( Vdep ){Ord_k}{Mix_k,ri_k} };
        %end
    %Vtemp = subs( Ckt.SYM_INLvdep{nV}{nL},	...
    %     	{CharCEL_Vdep{:}        Ckt.CharCEL_Vsrc{:}}, ...
    %        {Vdep_CEL{:}       	Vsrc_CEL{:}} );
    
end
