function [ Fresp ] = Fresp_SelectFMIX( Fresp, Opt, ...
    Fp2, MIX, Wnr, ...
    Opt_Print, Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

%=========================================== Input
%Fresp.IdxBD_fRESP( nRESP )       = [nBD  nmixBD  ]	nRESP in fmix_BD{nBD}
%=========================================== Output
%Fresp.IdxRCD_fRESP{ nRESP }      = [n    nMIX; ...]	nRESP in fmix_RCD{n}
%------------------------------
Fresp.fmixFLAG_RCD          = {};% { n }(nMIX, RI)=[1 1]       Generated/Needed by Wnr
    for n = 1 : MIX.N
        Fresp.fmixFLAG_RCD{n}           = zeros(size( MIX.fmix_RCD{n} ));% Initialize
    end
%Fresp.fmixFLAG_RCD_fSEPAR	= {};
%    for n = 1 : MIX.N
%        Fresp.fmixFLAG_RCD_fSEPAR{n}	= zeros(size( MIX.fmix_RCD{n} ));% Initialize
%    end
%------------------------------
%Fresp.IdxRCD_BD            = { nBD }{nmixBD} =[n  nMIX]	xxx_BD's ptr to xxx_RCD (for Build Chart)
%       lowest ord 1st by construction
%Fresp.fmixFLAG_BD          = { nBD }(nmixBD) =1

%% ########################### --> Fresp.IdxRCD_fRESP
switch Opt
%=========================================== Fresp.(IdxBD --> IdxRCD_fRESP)
    case{'IdxBD_fRESP'}
disp(['###################################################### Fresp.(IdxBD --> IdxRCD_fRESP)'])
Fresp.NumResp = size( Fresp.IdxBD_fRESP,1 );
for nRESP = 1 : Fresp.NumResp
    nBD     = Fresp.IdxBD_fRESP(nRESP,1);
    nmixBD	= Fresp.IdxBD_fRESP(nRESP,2);
    %-----------------------------
    Fresp.IdxRCD_fRESP{ nRESP } = MIX.IdxRCD_BD{nBD}{nmixBD};% [n  nMIX; ...]	nRESP in fmix_RCD{n}
        if(Opt_Disp)
            disp(['=========================================== [nRESP]=' num2str([nRESP])]);
            Fresp.IdxRCD_fRESP{ nRESP }%DEBUG
        end
end
%=========================================== Fresp.(fRESP --> IdxRCD_fRESP)
    case{'fRESP_MAT'}
disp(['###################################################### Fresp.(fRESP_MAT --> IdxRCD_fRESP)'])
Fresp.NumResp = size( Fresp.fRESP_MAT,1 );
for nRESP = 1 : Fresp.NumResp
    Fresp.IdxRCD_fRESP{ nRESP } = [];% Init
for n = 1 : MIX.N
    fmix = Fresp.fRESP_MAT(nRESP,:);
    %---------------------------------(nmixRCD,  nRI): find fRESP in MIX.fmix_RCD{n}
    [ nmixRCD  nRI ] = Mix_RCDsearch( fmix, MIX.fmix_RCD{n}, 1);
    if ~isempty( nmixRCD )
        Fresp.IdxRCD_fRESP{ nRESP } = [Fresp.IdxRCD_fRESP{ nRESP };  [n  nmixRCD]];
    end
    %---------------------------------XXXXXXX(nmixRCD,  nRI): find fRESP in MIX.fmix_RCD{n}
    %ri_FCT      = [ 1  -1 ];% bc "fmix_RCD" has only +Freq "fmix_VEC"
    %flagISFOUND = 0;
    %for nRI = 1 : 2
    %    [ nmixRCD ] = Find_VecIDX_Func( ri_FCT(nRI) * MIX.fmix_RCD{n}, fmix, 'MATRIX', [], 0);
    %    if ~isempty( nmixRCD )
    %        if(nRI == 2) disp(['WARNING!!! Conjugate-freq in Fresp.fRESP_MAT']);end
    %        flagISFOUND = 1; 
    %        break
    %    end
	%end
    %if(flagISFOUND)
    %    Fresp.IdxRCD_fRESP{ nRESP } = [Fresp.IdxRCD_fRESP{ nRESP };  [n  nmixRCD]];
    %end
end
	if(Opt_Disp)
      	disp(['=========================================== [nRESP]=' num2str([nRESP])]);
    	Fresp.IdxRCD_fRESP{ nRESP }%DEBUG
    end
end
%===========================================
end

%% ########################### Fresp.(IdxRCD_fRESP --> fmixFLAG_RCD)
disp(['###################################################### Fresp.(IdxRCD_fRESP --> fmixFLAG_RCD)'])
for nRESP = 1 : Fresp.NumResp
%===========================================
for nn = 1 : size( Fresp.IdxRCD_fRESP{ nRESP },1 )
    n    	= Fresp.IdxRCD_fRESP{ nRESP }(nn,1);
    nmixRCD	= Fresp.IdxRCD_fRESP{ nRESP }(nn,2);
    nri     = 1;% for measured
    %----------------------------- 
    Fresp.fmixSYM_fRESP{ nRESP }(nn,1) = MIX.fmixSYM_RCD{n}(nmixRCD);
	if(Opt_Disp) disp(['------------------------------------------- [nRESP n]=' num2str([nRESP  n]) '  ' char( Fresp.fmixSYM_fRESP{ nRESP }(nn) )]);end
    %----------------------------- Recur given (n, nmixRCD, nri) 
    if(Fresp.fmixFLAG_RCD{n}(nmixRCD, nri) == 0)% if path not traveled
        %compile INPUT fmix that contribute to (n, nmixRCD, nri) in MIX.fmix_RCD
        %Recurrsive func call bc: contributing fmix also arise from NL
        [ Fresp ] = Recur( n, nmixRCD, nri, ...
            Fresp, Fp2, MIX, Wnr, 0);
        %Fresp.fmixFLAG_RCD{n}(nmixRCD, nri) = 1;%XXXXXXX indicate path was traveled
    end
end
%===========================================
end

%% ########################### Fresp.(fmixFLAG_RCD  -->  IdxRCD_BD  fmixFLAG_BD)
[Fresp.fmixFLAG_BD  Fresp.IdxRCD_BD] = Fresp_BandSYM( Fresp.fmixFLAG_RCD, MIX);

disp(['%###################################################### Fresp.(fmixFLAG_RCD  -->  IdxRCD_BD  fmixFLAG_BD)'])
    if(Opt_Print)
        Print_Mix_BD( Fresp.IdxRCD_BD, MIX, 'IdxRCD_BD');
    end


%% **************************************************** fRESP  in  Fp2{n}
function [ Fresp ] = Recur( n, nmixRCD, nri, ...
    Fresp, Fp2, MIX, Wnr, ...
    Opt_Disp)
if(Opt_Disp)  disp(['%############################################[n, nmixRCD, nri] ' num2str([n, nmixRCD, nri])]); end

if(n == 1)
%=================================================================
    % LinSoln computed already
%=================================================================
else
for r = 2 : length( Fp2{n}{nmixRCD, nri}.wnr )
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )
	PolyOrd_VEC         = Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = Fp2{n}{ nmixRCD,nri }.wnr{r}{rC,1};% info from Fp2{n}{ nmixRCD,nri }
    PolyOrd_riMAT       = Fp2{n}{ nmixRCD,nri }.wnr{r}{rC,2};% info from Fp2{n}{ nmixRCD,nri }
for rMIX = 1 : size( PolyOrd_nMIXMAT,1)
%---------------------------------------------------- 
for k = 1 : length( PolyOrd_VEC )
	Ord_k	= PolyOrd_VEC(           k);
    Mix_k	= PolyOrd_nMIXMAT(  rMIX,k);
    ri_k    = PolyOrd_riMAT(    rMIX,k);
        if(ri_k == -1)
            nri_k = 2;
        else
            nri_k = 1;
        end
if( Fresp.fmixFLAG_RCD{Ord_k}(Mix_k, nri_k) == 0)% if path not traveled
	%compile INPUT fmix that contribute to (Mix_k, nri_k) in MIX.fmix_RCD{ Ord_k }
	%Recurrsive func call bc: contributing fmix also arise from NL
    [ Fresp ] = Recur( Ord_k, Mix_k, nri_k, ...
        Fresp, Fp2, MIX, Wnr, Opt_Disp);
    %Fresp.fmixFLAG_RCD{Ord_k}(Mix_k, nri_k) = 1;%XXXXXXX indicate path was traveled
end
end
%---------------------------------------------------- 
end
end
end
%=================================================================
end

	Fresp.fmixFLAG_RCD{n}(nmixRCD, nri) = 1;%XXXXXXX indicate path was traveled
return
%% ****************************************************  fRESP_fSEPAR  in  Fp2{n}
function [ Fresp ] = RecurLIN( n, nmixRCD, nri, ...
    Fresp, Fp2, MIX, Wnr, ...
    Opt_Disp)
if(Opt_Disp)  disp(['%############################################[n, nmixRCD, nri] ' num2str([n, nmixRCD, nri])]); end

if(n == 1)
%=================================================================
    % LinSoln computed already
%=================================================================
else
for r = 2 : length( Fp2{n}{nmixRCD, nri}.wnr )
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )
	PolyOrd_VEC         = Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = Fp2{n}{ nmixRCD,nri }.wnr{r}{rC,1};% info from Fp2{n}{ nmixRCD,nri }
    PolyOrd_riMAT       = Fp2{n}{ nmixRCD,nri }.wnr{r}{rC,2};% info from Fp2{n}{ nmixRCD,nri }
for rMIX = 1 : size( PolyOrd_nMIXMAT,1)
%---------------------------------------------------- 
for k = 1 : length( PolyOrd_VEC )
	Ord_k	= PolyOrd_VEC(           k);
    Mix_k	= PolyOrd_nMIXMAT(  rMIX,k);
    ri_k    = PolyOrd_riMAT(    rMIX,k);
        if(ri_k == -1)
            nri_k = 2;
        else
            nri_k = 1;
        end
if( Fresp.fmixFLAG_RCD_fSEPAR{Ord_k}(Mix_k, nri_k) == 0)% if path not traveled
    %??????????? Recur or RecurLIN ????????????
    %[ Fresp ] = Recur( Ord_k, Mix_k, nri_k, ...
    %RecurLIN: bc Fresp.fmixFLAG_RCD_fSEPAR need to be modified
    [ Fresp ] = RecurLIN( Ord_k, Mix_k, nri_k, ...
        Fresp, Fp2, MIX, Wnr, Opt_Disp);% Travel the path
    %Fresp.fmixFLAG_RCD_fSEPAR{Ord_k}(Mix_k, nri_k) = 1;% indicate path was traveled
end
end
%---------------------------------------------------- 
end
end
end
%=================================================================
end

	Fresp.fmixFLAG_RCD_fSEPAR{n}(nmixRCD, nri) = 1;%XXXXXXX indicate path was traveled
return
%% ###########################
if(0)

    %---------------------- Fresp.fmixFLAG_RCD_fSEPAR
    if( Fresp.fRESP_fSEPAR(nRESP) == 0)
        Fresp.fRESP_fSEPAR(nRESP) = n;
    if(Fresp.fmixFLAG_RCD_fSEPAR{n}(nmixRCD, nri) == 0)% if path not traveled
        %compile INPUT fmix that contribute to (n, nmixRCD, nri) in MIX.fmix_RCD
        %Recurrsive func call bc: contributing fmix also arise from NL
        [ Fresp ] = RecurLIN( n, nmixRCD, nri, ...
            Fresp, Fp2, MIX, Wnr, Opt_Disp);
        Fresp.fmixFLAG_RCD_fSEPAR{n}(nmixRCD, nri) = 1;%---XXXXXXX
    end
    end

end