function [z x_MA y_MA] = Cat_Func(x, y, Opt_DSB, Opt_Data)
if ~exist('Opt_DSB', 'var')
    Opt_DSB = 'None';
end
if ~exist('Opt_Data', 'var')
    Opt_Data = 'RI';
end
% MAT(Freq,Pwr):         Cat vertically along Freq
% VEC:
%   DSB &&  MA/dB:  	treat as MAT(Freq,Pwr), Cat vertically along Freq
%  !DSB || !MA/dB):     CAT-Dir follow x     (SCALAR CAT-Dir follow VEC)

if (isvector(x) && isvector(y))% SCALAR is also VEC
    %----------------------------------------------
    if (isequal(Opt_DSB,'Opt_DSB') && (isequal(Opt_Data,'MA')||isequal(Opt_Data,'dB')))
        %----------------------
        %treat as MAT(Freq,Pwr)
     	dimflip_x = 1;
        dimflip_y = 1;
    else
        %---------------------- VEC CAT-Dir follow x
        dimflip_x = DimFlip_Func(x);
        dimflip_y = DimFlip_Func(y);
        %++++++++++ SCALAR CAT-Dir follow VEC
        if isscalar(x)
            dimflip_x = dimflip_y;
        elseif isscalar(y)
            dimflip_y = dimflip_x;
        end
    end
else% MAT(Freq,Pwr): Cat vertically along Freq
    %----------------------------------------------
    %must have (Opt_DSB, Opt_Data=MA/dB)
    dimflip_x = 1;
    dimflip_y = 1;
end

%%
switch Opt_DSB
    %----------------------------------------------
    case {'None'}
        if (dimflip_x == dimflip_y)
            z = cat(dimflip_x, x, y);
        else
            z = cat(dimflip_x, x, y.');
        end
    %----------------------------------------------
    case {'DSB'}% FLIP(x)
        x_MA = x;
        if (dimflip_x == dimflip_y)
        	y_MA = y;
        else
        	y_MA = y.';
        end
        switch Opt_Data
            case {'MA','dB'}
                Pha      	= [imag(x(1,:));...
                               imag(y_MA(1,:))];
                Pha_UnWrap	= unwrap(Pha/180*pi) /pi*180;%unwrap(each COL) by default 
                Offset      = Pha_UnWrap(2,:) - imag(y_MA(1,:))%match phase to y_MA_UnWraped = Pha_UnWrap(2,:)
                y_MA = y_MA + j*repmat(Offset,[size(y_MA,1) 1]);
        end
        z = cat(dimflip_x, flipdim(x,dimflip_x), y_MA);
    %----------------------------------------------
end

%% TEST
if(0)
    
switch Opt_Disp
    case {'disp'}
        [size(x) dimflip_x; ...
         size(y) dimflip_y]
end

switch Opt_Disp
    case {'disp'}
        [z(1)   z(end)]
end

end