%% Plot vs df (Interpolation)
%########################################################################
Seg_Stop   	= 4 * NumSeg_Stop;
Seg_Start  	= 4 * (NumSeg_Start-1) + 1;
H3L_avg     = H3_MovAvg( File_Stop,(Seg_Start:4:Seg_Stop) );
Seg_Start	= 4 * (NumSeg_Start-1) + 4;
H3H_avg     = H3_MovAvg( File_Stop,(Seg_Start:4:Seg_Stop) );
%
fig_Vec3 = [5 6];
figure(fig_Vec3(1))
semilogx( SigGen_Seg_dfim3,abs(H3L_avg),'-bo', SigGen_Seg_dfim3,abs(H3H_avg),'-rx'); grid on; hold on;
figure(fig_Vec3(2))
semilogx( SigGen_Seg_dfim3,angle(H3L_avg)/pi*180,'-bo', SigGen_Seg_dfim3,angle(H3H_avg)/pi*180,'-rx'); grid on; hold on;

method = 'linear';
%#################### MA             (More ACCUR for MAG-PHA PLOT)
H3L_Mag_Itp = interp1(SigGen_Seg_dfim3,abs(H3L_avg), SigGen_Seg_df,method,'extrap'); % );% 
H3H_Mag_Itp = interp1(SigGen_Seg_dfim3,abs(H3H_avg), SigGen_Seg_df,method,'extrap'); % );%
H3L_Pha_Itp = interp1(SigGen_Seg_dfim3,angle(H3L_avg)/pi*180, SigGen_Seg_df,method,'extrap'); % );% 
H3H_Pha_Itp = interp1(SigGen_Seg_dfim3,angle(H3H_avg)/pi*180, SigGen_Seg_df,method,'extrap'); % );%
%
figure(fig_Vec3(1))     %figure(fig_Vec1(1))
semilogx( SigGen_Seg_df,abs(H3L_Mag_Itp),'-ko', SigGen_Seg_df,abs(H3H_Mag_Itp),'-gx'); grid on; hold on;
figure(fig_Vec3(2))     %figure(fig_Vec1(2))
semilogx( SigGen_Seg_df,H3L_Pha_Itp,'-ko', SigGen_Seg_df,H3H_Pha_Itp,'-gx'); grid on; hold on;

%#################### LogScale Mag + Pha    (More ACCUR for LOG-SCALE)
H3L_Mag_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,abs(H3L_avg), Lin2dB(SigGen_Seg_df)/20,method,'extrap'); % );% 
H3H_Mag_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,abs(H3H_avg), Lin2dB(SigGen_Seg_df)/20,method,'extrap'); % );%
H3L_Pha_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,angle(H3L_avg)/pi*180, Lin2dB(SigGen_Seg_df)/20,method,'extrap'); % );% 
H3H_Pha_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,angle(H3H_avg)/pi*180, Lin2dB(SigGen_Seg_df)/20,method,'extrap'); % );%
%
figure(fig_Vec3(1))     %figure(fig_Vec1(1))
semilogx( SigGen_Seg_df,abs(H3L_Mag_Itp),'-co', SigGen_Seg_df,abs(H3H_Mag_Itp),'-mx'); grid on; hold on;
figure(fig_Vec3(2))     %figure(fig_Vec1(2))
semilogx( SigGen_Seg_df,H3L_Pha_Itp,'-co', SigGen_Seg_df,H3H_Pha_Itp,'-mx'); grid on; hold on;


%#################### RI
H3L_Itp = interp1(SigGen_Seg_dfim3,real(H3L_avg), SigGen_Seg_df,method,'extrap') ...
    + j*interp1(SigGen_Seg_dfim3,imag(H3L_avg), SigGen_Seg_df,method,'extrap');
H3H_Itp = interp1(SigGen_Seg_dfim3,real(H3H_avg), SigGen_Seg_df,method,'extrap') ...
    + j*interp1(SigGen_Seg_dfim3,imag(H3H_avg), SigGen_Seg_df,method,'extrap');
%
figure(fig_Vec3(1))
semilogx( SigGen_Seg_df,abs(H3L_Itp),'-kd', SigGen_Seg_df,abs(H3H_Itp),'-g+'); grid on; hold on;
figure(fig_Vec3(2))
semilogx( SigGen_Seg_df,angle(H3L_Itp)/pi*180,'-kd', SigGen_Seg_df,angle(H3H_Itp)/pi*180,'-g+'); grid on; hold on;

%#################### LogScale RI
H3L_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,real(H3L_avg), Lin2dB(SigGen_Seg_df)/20,method,'extrap') ...
    + j*interp1(SigGen_Seg_dfim3,imag(H3L_avg), SigGen_Seg_df,method,'extrap');
H3H_Itp = interp1(Lin2dB(SigGen_Seg_dfim3)/20,real(H3H_avg), Lin2dB(SigGen_Seg_df)/20,method,'extrap') ...
    + j*interp1(SigGen_Seg_dfim3,imag(H3H_avg), SigGen_Seg_df,method,'extrap');
%
figure(fig_Vec3(1))
semilogx( SigGen_Seg_df,abs(H3L_Itp),'-cd', SigGen_Seg_df,abs(H3H_Itp),'-m+'); grid on; hold on;
figure(fig_Vec3(2))
semilogx( SigGen_Seg_df,angle(H3L_Itp)/pi*180,'-cd', SigGen_Seg_df,angle(H3H_Itp)/pi*180,'-m+'); grid on; hold on;

% Interp2 Real + Imag (NOT Necessary)
legend('IM3L', 'IM3H', 'Mag-Pha', 'Mag-Pha', 'Real-Imag', 'Real-Imag', ...
    'LOG Mag-Pha', 'LOG Mag-Pha', 'LOG Real-Imag', 'LOG Real-Imag');


