function [ Fresp ] = INL_Fresp_SelectFMIX( Fresp, ...
    F, MIX, Wnr, ...
    Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

%Fresp.fRESP        = [k l]
Fresp.fRESP_IDX     = zeros( size( Fresp.fRESP,1 ), length( F ) );% (nRESP,n) = nRESP_IDX
Fresp.fRESP_RI      = zeros( size( Fresp.fRESP,1 ), 1 );% (nRESP,1) = ri_RESP
%--------
Fresp.fRESP_fSEPAR	= zeros( size( Fresp.fRESP,1 ), 1 );% (nRESP,1) = n
%------------------------------
%compile INPUT fmix that contribute to fRESP
%Recurrsive func call bc: contributing fmix also arise from NL
Fresp.fmix          = {};% {n,1}(nMIX,RI) = [1 1] Generated/Needed by Wnr
%--------
Fresp.fmix_fSEPAR	= {};% {n,1}(nMIX,RI) = [1 1] Generated/Needed by Wnr
%% ########################### Fresp.fmix{n,1}(nMIX, ri)
for n = 1 : length( F )
    Fresp.fmix{n,1}         = zeros(size( MIX.fmix_RCD{n} ));% Initialize
    Fresp.fmix_fSEPAR{n,1}	= zeros(size( MIX.fmix_RCD{n} ));% Initialize
for nRESP = 1 : size( Fresp.fRESP,1 )
    if(Opt_Disp)  disp(['%##############################################################[nRESP n]=' num2str([nRESP  n])]); end
    fmix = Fresp.fRESP(nRESP,:);
%---------------------------------XXXXXXX(nRESP_IDX,  ri_RESP): find fRESP in MIX.fmix_RCD{n}
ri_FCT = [ 1	-1 ];% bc "fmix_RCD" has only +Freq "fmix_VEC"
flagISFOUND = 0;
for ri_RESP = 1 : 2
    [ nRESP_IDX     xXORy_IDX	yVEC_IDX	yXORy_IDX] = Find_VecIDX_Func( ...
        ri_FCT(ri_RESP) * MIX.fmix_RCD{n}, ...
        fmix, 'MATRIX', [], 0);
    if ~isempty( nRESP_IDX )
        flagISFOUND = 1;
        break
    end
end
    if(flagISFOUND && (ri_RESP == 2))
        disp(['WARNING!!! Conjugate-freq in Fresp.fRESP: NOT necessary since it cant be measured']);
        [ n     nRESP	fmix]
    end
%---------------------------------XXXXXXX Recur given (n, nRESP_IDX, ri_RESP)
if ~isempty( nRESP_IDX )
    if(Opt_Disp)
        % F{n}{nRESP_IDX, ri_RESP}
        fmix% DEBUG
    end
	%---------------------- fRESP in MIX.fmix_RCD{n}
	Fresp.fRESP_IDX( nRESP,n )	= nRESP_IDX;
	Fresp.fRESP_RI( nRESP,1 )	= ri_RESP;% dont need bc want +fRESP
    %---------------------- Fresp.fmix
    if(Fresp.fmix{n,1}(nRESP_IDX, ri_RESP) == 0)% if path not traveled
        %compile INPUT fmix that contribute to (nRESP_IDX,  ri_RESP) in MIX.fmix_RCD{n}
        %Recurrsive func call bc: contributing fmix also arise from NL
        [ Fresp ] = Recur( n, nRESP_IDX, ri_RESP, ...
            Fresp, F, MIX, Wnr, Opt_Disp);
        Fresp.fmix{n,1}(nRESP_IDX, ri_RESP) = 1;%-----XXXXXXX
    end
    %---------------------- Fresp.fmix_fSEPAR
    if( Fresp.fRESP_fSEPAR(nRESP) == 0)
        Fresp.fRESP_fSEPAR(nRESP) = n;
    if(Fresp.fmix_fSEPAR{n,1}(nRESP_IDX, ri_RESP) == 0)% if path not traveled
        %compile INPUT fmix that contribute to (nRESP_IDX,  ri_RESP) in MIX.fmix_RCD{n}
        %Recurrsive func call bc: contributing fmix also arise from NL
        [ Fresp ] = RecurLIN( n, nRESP_IDX, ri_RESP, ...
            Fresp, F, MIX, Wnr, Opt_Disp);
        Fresp.fmix_fSEPAR{n,1}(nRESP_IDX, ri_RESP) = 1;%-----XXXXXXX
    end
    end
    %---------------------- 
end
%---------------------------------------------------- 
end
end
%% **************************************************** fRESP  in  F{n}
function [ Fresp ] = Recur( n, nRESP_IDX, ri_RESP, ...
    Fresp, F, MIX, Wnr, ...
    Opt_Disp)
if(Opt_Disp)  disp(['%############################################[n, nRESP_IDX, ri_RESP] ' num2str([n, nRESP_IDX, ri_RESP])]); end

if(n == 1)
%=================================================================
    Fresp.fmix{n,1}(nRESP_IDX, ri_RESP) = 1;
%=================================================================
else
for r = 2 : length( F{n}{nRESP_IDX, ri_RESP}.wnr )
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )
	PolyOrd_VEC         = Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = F{n}{ nRESP_IDX,ri_RESP }.wnr{r}{rC,1};% info from F{n}{ nRESP_IDX,ri_RESP }
    PolyOrd_riVECMAT    = F{n}{ nRESP_IDX,ri_RESP }.wnr{r}{rC,2};% info from F{n}{ nRESP_IDX,ri_RESP }
for rMIX = 1 : size( PolyOrd_nMIXMAT,1)
%---------------------------------------------------- 
for k = 1 : length( PolyOrd_VEC )
	Ord_k	= PolyOrd_VEC(           k);
    Mix_k	= PolyOrd_nMIXMAT(  rMIX,k);
    ri_k    = PolyOrd_riVECMAT( rMIX,k);
        if(ri_k == -1)
            ri_k = 2;
        end
if( Fresp.fmix{Ord_k,1}(Mix_k, ri_k) == 0)% if path not traveled
	%compile INPUT fmix that contribute to (Mix_k, ri_k) in MIX.fmix_RCD{ Ord_k }
	%Recurrsive func call bc: contributing fmix also arise from NL
    [ Fresp ] = Recur( Ord_k, Mix_k, ri_k, ...
        Fresp, F, MIX, Wnr, Opt_Disp);
    Fresp.fmix{Ord_k,1}(Mix_k, ri_k) = 1;%-----XXXXXXX
end
end
%---------------------------------------------------- 
end
end
end
end
%=================================================================
%% ****************************************************  fRESP_fSEPAR  in  F{n}
function [ Fresp ] = RecurLIN( n, nRESP_IDX, ri_RESP, ...
    Fresp, F, MIX, Wnr, ...
    Opt_Disp)
if(Opt_Disp)  disp(['%############################################[n, nRESP_IDX, ri_RESP] ' num2str([n, nRESP_IDX, ri_RESP])]); end

if(n == 1)
%=================================================================
    Fresp.fmix_fSEPAR{n,1}(nRESP_IDX, ri_RESP) = 1;
%=================================================================
else
for r = 2 : length( F{n}{nRESP_IDX, ri_RESP}.wnr )
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )
	PolyOrd_VEC         = Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = F{n}{ nRESP_IDX,ri_RESP }.wnr{r}{rC,1};% info from F{n}{ nRESP_IDX,ri_RESP }
    PolyOrd_riVECMAT    = F{n}{ nRESP_IDX,ri_RESP }.wnr{r}{rC,2};% info from F{n}{ nRESP_IDX,ri_RESP }
for rMIX = 1 : size( PolyOrd_nMIXMAT,1)
%---------------------------------------------------- 
for k = 1 : length( PolyOrd_VEC )
	Ord_k	= PolyOrd_VEC(           k);
    Mix_k	= PolyOrd_nMIXMAT(  rMIX,k);
    ri_k    = PolyOrd_riVECMAT( rMIX,k);
        if(ri_k == -1)
            ri_k = 2;
        end
if( Fresp.fmix_fSEPAR{Ord_k,1}(Mix_k, ri_k) == 0)% if path not traveled
    %??????????? Recur or RecurLIN ????????????
    %[ Fresp ] = Recur( Ord_k, Mix_k, ri_k, ...
    %RecurLIN: bc Fresp.fmix_fSEPAR need to be modified
    [ Fresp ] = RecurLIN( Ord_k, Mix_k, ri_k, ...
        Fresp, F, MIX, Wnr, Opt_Disp);% Travel the path
    Fresp.fmix_fSEPAR{Ord_k,1}(Mix_k, ri_k) = 1;% indicate path was traveled
end
end
%---------------------------------------------------- 
end
end
end
end
%=================================================================
%% ###########################
if(0)

    if(length( Fresp.fmix ) < Ord_k)
        Fresp.fmix{Ord_k} = [];
    end
    if(size( Fresp.fmix{Ord_k},1 ) < Mix_k)
        Fresp.fmix{Ord_k}(Mix_k,:) = [0 0];
    end
    %##### can't use bc: RCD_IDX found is not in sequence of Fresp.fRESP
    %[ RCD_IDX	RCDXOR_IDX	PART_IDX	PARTXOR_IDX] = Find_VecIDX_Func( ...
    %    MIX.fmix_RCD{n}, Fresp.fRESP, 'MATRIX', [], 0);

    for n = 1 : size( Fresp.fRESP_IDX, 2)
        if( ~isempty(Fresp.fRESP_IDX{ nRESP,n }) && ...
        	~isequal( Fresp.fRESP_IDX{ nRESP,n }, zeros(size( Fresp.fRESP_IDX{ nRESP,n } ))))
            nRESP_IDX	= Fresp.fRESP_IDX{ nRESP,n }(1);
            %ri_RESP 	= Fresp.fRESP_IDX{ nRESP,n }(2);
            break
        end
    end

end