function [ Mn  Fm  Fm_ ] = INL_Mult( N, MIX, ...
    Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

%% ###################################################### Mn (like Wnr for INL_Poly)
for n = 1 : N
    Mn.PolyOrd_MAT{n} = [];% initialize
end

for nU = 1 : N
for nV = 1 : N
    n = nV + nU;
    if( n <= N )
        Mn.PolyOrd_MAT{n} = [Mn.PolyOrd_MAT{n};  [nV  nU]];
    end
end
end

%% ###################################################### init
for n = 1 : N
    Fm_{n} = zeros( size(MIX.fmix_RCD{n},1), 2);
for nRESP = 1 : size( MIX.fmix_RCD{n},1 )
%----------------------------------------------------------------- init .wnr
for rC = 1 : size( Mn.PolyOrd_MAT{n},1 )
    for nRI = 1 : 2
        Fm{n}{nRESP,nRI}.Mn{rC,1} = [];% PolyOrd_nMIXMAT
        Fm{n}{nRESP,nRI}.Mn{rC,2} = [];% PolyOrd_riMAT
        Fm{n}{nRESP,nRI}.Mn{rC,3} = [];% PolyOrd_coefVEC
    end
end
%----------------------------------------------------------------- init .fmix
for k = 1 : N
    %for nmixRCD = 1 : size( MIX.fmix_RCD{k},1 )
    for nRI = 1 : 2
        Fm{n}{nRESP,nRI}.fmix{k,1} = zeros( size( MIX.fmix_RCD{k},1), 2);
    end
    %end
end
    %------------------------------ Lin-fResp for 2Tone
    %if(n == 1)
    %    Fm{1}{nRESP,1}.fmix{1}(nRESP,:) = [1 0];
    %    Fm{1}{nRESP,2}.fmix{1}(nRESP,:) = [0 1];
    %end
%-----------------------------------------------------------------
end
end

%% ###################################################### Fm  Fm_
tic
for n = 2 : N
for rC = 1 : size( Mn.PolyOrd_MAT{n},1 )
    nV          = Mn.PolyOrd_MAT{n}(rC,1);
    nU          = Mn.PolyOrd_MAT{n}(rC,2);
%PolyOrd_VEC	= Mn.PolyOrd_MAT{n}(rC,:);% [nV nU]
%=================================================================
    %iterate all possible nmixRCD/nRI @(current position in VEC)
    %Recurrsive func call bc: VEC is variable length, can't use for-loop
for riV = 1 : -2 : -1
    mixStartV = 1;
    if (riV == -1) && isequal( MIX.fmix_RCD{nV}(1,:), zeros( size(MIX.fmix_RCD{nV}(1,:)) ) )
        mixStartV = 2;% skip double-counting if DC (sorted to be 1st-pt)
    end
for riU = 1 : -2 : -1
    mixStartU = 1;
    if (riU == -1) && isequal( MIX.fmix_RCD{nU}(1,:), zeros( size(MIX.fmix_RCD{nU}(1,:)) ) )
        mixStartU = 2;% skip double-counting if DC (sorted to be 1st-pt)
    end
%PolyOrd_riVEC	= [riV  riU];
%-----------------------------------------------------------------
for nmixRCDV = mixStartV : size( MIX.fmix_RCD{nV},1 )
for nmixRCDU = mixStartU : size( MIX.fmix_RCD{nU},1 )
    fmixVEC_V  	= MIX.fmix_RCD{nV}(nmixRCDV,:);
    fmixVEC_U 	= MIX.fmix_RCD{nU}(nmixRCDU,:);
%PolyOrd_nMIXVEC = [nmixRCDV  nmixRCDU];
    %---------------------------------------------------- 
	% reaches final position in VEC: can calc Result fmix_VEC ~OUTPUT
    fmixVEC         = fmixVEC_V * riV + fmixVEC_U * riU;% calc Result fmix_VEC ~OUTPUT
    [ nmixRCD  nRI ]	= Mix_RCDsearch( fmixVEC, MIX.fmix_RCD{n});
        Fm{n}{ nmixRCD, nRI}.Mn{rC,1} = [Fm{n}{ nmixRCD, nRI}.Mn{rC,1};   [nmixRCDV	nmixRCDU]];
        Fm{n}{ nmixRCD, nRI}.Mn{rC,2} = [Fm{n}{ nmixRCD, nRI}.Mn{rC,2};   [riV        riU]];
        Fm{n}{ nmixRCD, nRI}.fmix{n,1}(nmixRCD, nRI) = 1;
        Fm_{n}( nmixRCD, nRI) = 1;% indicate fIM generated
    %---------------------------------------------------- 
        if(riV == -1)
            Fm{n}{nmixRCD, nRI}.fmix{nV,1}(nmixRCDV, 2) = 1;
        else
            Fm{n}{nmixRCD, nRI}.fmix{nV,1}(nmixRCDV, 1) = 1;
        end
        if(riU == -1)
            Fm{n}{nmixRCD, nRI}.fmix{nU,1}(nmixRCDU, 2) = 1;
        else
            Fm{n}{nmixRCD, nRI}.fmix{nU,1}(nmixRCDU, 1) = 1;
        end
    % for NL-Cap, keep track of 'jw' contributions (to the same fresp) in a list ?
    % can use same Wnr expansion: need further modification
    %---------------------------------------------------- 
end
end
%-----------------------------------------------------------------
end
end
%=================================================================
    
end
end
toc
