function [ Fp  Fp_ ] = INL_Poly( N, MIX, Wnr, ...
    Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

%% ###################################################### initialize
for n = 1 : N
    Fp_{n} = zeros( size(MIX.fmix_RCD{n},1), 2);
for nRESP = 1 : size( MIX.fmix_RCD{n},1 )
%----------------------------------------------------------------- init .wnr
for r = 2 : n
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r},1 )
    for nri = 1 : 2
        Fp{n}{nRESP,nri}.wnr{r}{rC,1} = [];% PolyOrd_nMIXMAT
        Fp{n}{nRESP,nri}.wnr{r}{rC,2} = [];% PolyOrd_riMAT
    end
end
end
%----------------------------------------------------------------- init .fmix
for k = 1 : N
    %for nMIX = 1 : size( MIX.fmix_RCD{k},1 )
    for nri = 1 : 2
        Fp{n}{nRESP,nri}.fmix{k,1} = zeros( size( MIX.fmix_RCD{k},1), 2);
    end
    %end
end
    %------------------------------ Lin-fResp for 2Tone
    if(n == 1)
        Fp{1}{nRESP,1}.fmix{1}(nRESP,:) = [1 0];
        Fp{1}{nRESP,2}.fmix{1}(nRESP,:) = [0 1];
    end
%-----------------------------------------------------------------
end
end

%% ###################################################### 
tic
for n = 2 : N
for r = 2 : n
%-----------------------------------------------------------------
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )
    PolyOrd_IDX   	= 1;% (current position in VEC)
	PolyOrd_VEC     = Wnr.PolyOrd_MAT{n,r}(rC,:);% [ord ord ...]
    PolyOrd_nMIXVEC	= [];% [nMIX nMIX ...]
    PolyOrd_riVEC	= [];% [ri   ri   ...]
	if(Opt_Disp)
     	disp('%=========================================')
       	PolyOrd_VEC
	end
    %iterate all possible nMIX/nri @(current position in VEC)
    %Recurrsive func call bc: VEC is variable length, can't use for-loop
    [ Fp{n}	Fp_{n}] = INL_Fnr_ForRecur( MIX.fmix_RCD, PolyOrd_VEC, ...
        PolyOrd_IDX, PolyOrd_nMIXVEC, PolyOrd_riVEC, ...
        n, r, rC, Fp{n}, Fp_{n}, Opt_Disp);
end
%-----------------------------------------------------------------
end
        if(Opt_Disp)
            %sprintf('Fp_{%d}:',n)    sprintf(' %d ',Fp_{n})    sprintf(' \n')
            Fn_ = Fp_{n}
        end
end
toc

%% ###################################################### INL_Fnr_ForRecur
function [ Fn	Fn_ ] = INL_Fnr_ForRecur( fmix_RCD, PolyOrd_VEC, ...
    PolyOrd_IDX, PolyOrd_nMIXVEC, PolyOrd_riVEC, ...
    n, r, rC, Fn, Fn_, Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

%ord @(current position in VEC)
nORD = PolyOrd_VEC( PolyOrd_IDX );
    if(Opt_Disp)
        disp('%----------------------------------------')
        sprintf('PolyOrd_IDX=%d     nORD=%d', PolyOrd_IDX, nORD)
    end
%----------------------------------------------------XXXXXXX set Constituent fmix ~INPUT
%iterate all possible nMIX/nri @(current position in VEC)
for ri = 1 : -2 : -1
    PolyOrd_riVEC( PolyOrd_IDX )    = ri;
	nMIXstart = 1;
    if (ri == -1) && isequal( fmix_RCD{nORD}(1,:), zeros( size(fmix_RCD{nORD}(1,:)) ) )
        nMIXstart = 2;% skip double-counting if DC (sorted to be 1st-pt)
    end
    %nMIXstart% DEBUG
for nMIX = nMIXstart : size( fmix_RCD{nORD}, 1 )
    PolyOrd_nMIXVEC( PolyOrd_IDX )  = nMIX;
%-----------------------------------------------------------------
if( PolyOrd_IDX < length( PolyOrd_VEC ) )% not at final position in VEC
    %############### Don't forget to modify
    %iterate all possible nMIX/nri @(current position in VEC)
    %Recurrsive func call bc: VEC is variable length, can't use for-loop
	[ Fn	Fn_ ] = INL_Fnr_ForRecur( fmix_RCD, PolyOrd_VEC, ...
    	PolyOrd_IDX+1, PolyOrd_nMIXVEC, PolyOrd_riVEC, ...
        n, r, rC, Fn, Fn_, Opt_Disp);
else% reaches final position in VEC: can calc Result fmix_VEC ~OUTPUT
    [ Fn    Fn_ ] = INL_Fnr_fmixVEC( fmix_RCD, PolyOrd_VEC, ...
        PolyOrd_nMIXVEC, PolyOrd_riVEC, ...
        n, r, rC, Fn, Fn_, Opt_Disp);
end
%-----------------------------------------------------------------
end
end

%% ****************************************************
function [ Fn	Fn_ ] = INL_Fnr_fmixVEC( fmix_RCD, PolyOrd_VEC, ...
    PolyOrd_nMIXVEC, PolyOrd_riVEC, ...
    n, r, rC, Fn, Fn_, Opt_Disp)

%----------------------------------------------------XXXXXXX calc Result fmix_VEC ~OUTPUT
fmix_VEC = [];
for k = 1 : length( PolyOrd_VEC )
    Ord_k   = PolyOrd_VEC(k);
    Mix_k   = PolyOrd_nMIXVEC(k);
    ri_k    = PolyOrd_riVEC(k);
	fmix_VEC = [fmix_VEC;       fmix_RCD{ Ord_k }(Mix_k,:) * ri_k];
end
    if(Opt_Disp)
        disp('%--------------------')
        %PolyOrd_nMIXVEC
        %PolyOrd_riVEC
        fmix_VEC
    end
fmix_VEC = sum( fmix_VEC, 1 );
%---------------------------------------------------- find fmix_VEC in fmix_RCD{n} = nmix
%---------------------------------------------------- Fn{ nmix,nri }.wnr{r}{rC,:} = {nMIXVEC  riVEC}
[ nmix  nri ]	= Mix_RCDsearch( fmix_VEC, fmix_RCD{n});
    Fn{ nmix, nri}.wnr{r}{rC,1} = [Fn{ nmix, nri}.wnr{r}{rC,1};	PolyOrd_nMIXVEC];
    Fn{ nmix, nri}.wnr{r}{rC,2} = [Fn{ nmix, nri}.wnr{r}{rC,2};   PolyOrd_riVEC];
    Fn{ nmix, nri}.fmix{n,1}(nmix, nri) = 1;
    Fn_( nmix, nri) = 1;
%ri_FCT = [ 1	-1 ];% bc "fmix_RCD" has only +Freq "fmix_VEC"
%for nri = 1 : 2
%    [ nmix     xXORy_IDX	yVEC_IDX	yXORy_IDX] = Find_VecIDX_Func( ...
%        ri_FCT(nri) * fmix_RCD{n}, ...
%        fmix_VEC, 'MATRIX', [], 0);
%    if ~isempty( nmix )
%        break
%    end
%end
    %if(nri == 2)
    %    disp(['WARNING!!! Conjugate-freq in F_PART.fmix: NOT necessary since it cant be measured']);
    %end
%---------------------------------------------------- Fn{ nmix,nri }.fmix( PolyOrd, nMIXVEC, riVEC ) = 1
for k = 1 : length( PolyOrd_VEC )
    Ord_k	= PolyOrd_VEC(k);
    Mix_k	= PolyOrd_nMIXVEC(k);
    ri_k    = PolyOrd_riVEC(k);
        if(ri_k == -1)
            nri_k = 2;
        else
            nri_k = 1;
        end
	Fn{ nmix, nri}.fmix{Ord_k,1}(Mix_k, nri_k) = 1;
    % for NL-Cap, keep track of 'jw' contributions (to the same fresp) in a list ?
    % can use same Wnr expansion: need further modification
end
