function [ Fp2 ] = INL_Poly_Condense( Fp, Wnr, MIX, Opt, Opt_Disp,...
    RCD_IDX, N)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

switch Opt
%% =============================================
    case{'Select'}
for n = 1 : N
for nRESP = 1 : size( RCD_IDX.nMIX, 1 )
	nmix	= RCD_IDX.nMIX(nRESP,n);
	nri 	= RCD_IDX.ri(nRESP,n);
if(nmix ~= 0)
	if(Opt_Disp)
        disp( sprintf('============================================================ n=%-5d  nMIX=%-5d  ri=%-5d  fmixSYM=%-s', ...
       	n, nmix, nri, char(MIX.fmixSYM_RCD{n}(nmix))) );
    end
%################################################################################################
for r = 2 : n
    if(Opt_Disp) 
        disp(['%============================================[r]=' num2str([r])]);
        Wnr.OrdPwr_MAT{n,r}
        Wnr.PolyOrd_MAT{n,r}
        Wnr.c_VEC{n,r}
	end
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )%size( Fp{n}{ nmix,nri }.wnr{r}, 1 )%
    PolyOrd_VEC      	= Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = Fp{n}{ nmix,nri }.wnr{r}{rC,1};
    PolyOrd_riMAT       = Fp{n}{ nmix,nri }.wnr{r}{rC,2};
    if(Opt_Disp) 
        disp(['%--------------------------------------------[rC]=' num2str([rC])]);
    end
if(size( PolyOrd_nMIXMAT, 1 ) > 0)
%============================================================rMIX
[ PolyOrd_nMIXMAT_2  PolyOrd_riMAT_2  PolyOrd_coefVEC_2 ] = Poly_Condense( PolyOrd_VEC, ...
    PolyOrd_nMIXMAT, PolyOrd_riMAT, Opt_Disp);
Fp2{n}{ nmix,nri }.wnr{r}{rC,1} = PolyOrd_nMIXMAT_2;
Fp2{n}{ nmix,nri }.wnr{r}{rC,2} = PolyOrd_riMAT_2;
Fp2{n}{ nmix,nri }.wnr{r}{rC,3} = PolyOrd_coefVEC_2;
%============================================================
end
    if(Opt_Disp) 
        PolyOrd_nMIXMAT
        PolyOrd_riMAT
        disp( sprintf('%################mix = %d reduced to %d', size(PolyOrd_nMIXMAT,1), size(PolyOrd_nMIXMAT_2,1)) );
        PolyOrd_nMIXMAT_2
        PolyOrd_riMAT_2
        PolyOrd_coefVEC_2
    end
end
end
%################################################################################################
end
end
end
%% =============================================
    case{'ALL'}
for n           = 1 : length( Fp )
for nmix	= 1 : size( Fp{n},1 )
for nri     = 1 : size( Fp{n},2 )
%################################################################################################
for r = 2 : n
    if(Opt_Disp) 
        disp(['%============================================[r]=' num2str([r])]);
        Wnr.OrdPwr_MAT{n,r}
        Wnr.PolyOrd_MAT{n,r}
        Wnr.c_VEC{n,r}
	end
for rC = 1 : size( Wnr.PolyOrd_MAT{n,r}, 1 )%size( Fp{n}{ nmix,nri }.wnr{r}, 1 )%
    PolyOrd_VEC      	= Wnr.PolyOrd_MAT{n,r}(rC,:);
    PolyOrd_nMIXMAT     = Fp{n}{ nmix,nri }.wnr{r}{rC,1};
    PolyOrd_riMAT       = Fp{n}{ nmix,nri }.wnr{r}{rC,2};
    if(Opt_Disp) 
        disp(['%--------------------------------------------[rC]=' num2str([rC])]);
        PolyOrd_nMIXMAT
        PolyOrd_riMAT
    end
if(size( PolyOrd_nMIXMAT, 1 ) > 0)
%============================================================rMIX
[ PolyOrd_nMIXMAT_2  PolyOrd_riMAT_2  PolyOrd_coefVEC_2 ] = Poly_Condense( PolyOrd_VEC, ...
    PolyOrd_nMIXMAT, PolyOrd_riMAT, Opt_Disp);
Fp2{n}{ nmix,nri }.wnr{r}{rC,1} = PolyOrd_nMIXMAT_2;
Fp2{n}{ nmix,nri }.wnr{r}{rC,2} = PolyOrd_riMAT_2;
Fp2{n}{ nmix,nri }.wnr{r}{rC,3} = PolyOrd_coefVEC_2;
%============================================================
end
    if(Opt_Disp) 
        disp(['%###############']);
        PolyOrd_nMIXMAT_2
        PolyOrd_riMAT_2
        PolyOrd_coefVEC_2
        disp( sprintf('#mix = %d reduced to %d', size(PolyOrd_nMIXMAT,1), size(PolyOrd_nMIXMAT_2,1)) );
    end
end
end
%################################################################################################
end
end
end
%% ============================================= 
end

%% ######################################################
function [ PolyOrd_nMIXMAT_2  PolyOrd_riMAT_2  PolyOrd_coefVEC_2 ] = Poly_Condense( PolyOrd_VEC, ...
    PolyOrd_nMIXMAT, PolyOrd_riMAT, Opt_Disp)

PolyOrd_nMIXMAT_2	= PolyOrd_nMIXMAT(1,:);% Init
PolyOrd_riMAT_2     = PolyOrd_riMAT(1,:);% Init
PolyOrd_coefVEC_2 	= [1];% Init

for rMIX = 2 : size( PolyOrd_nMIXMAT, 1 )
    isFOUND = 0;
    %----------------------------------------------------------------- 
    for rMIX_2 = 1 : size( PolyOrd_nMIXMAT_2, 1 )
        [ isFOUND ] = isSAME_Permute( PolyOrd_VEC, ...
            PolyOrd_nMIXMAT(rMIX,:),        PolyOrd_riMAT(rMIX,:), ...
            PolyOrd_nMIXMAT_2(rMIX_2,:),  	PolyOrd_riMAT_2(rMIX_2,:) );
        if( isFOUND )% already exist in *_2
            break
        end
    end
    %----------------------------------------------------------------- 
    if( isFOUND )% already exist in *_2
        PolyOrd_coefVEC_2( rMIX_2 ) = PolyOrd_coefVEC_2( rMIX_2 ) + 1;
            if( Opt_Disp )
                disp(['%############### [rMIX rMIX_2]=' num2str([rMIX rMIX_2])]);
                %[PolyOrd_nMIXMAT(rMIX,:);	PolyOrd_nMIXMAT_2(rMIX_2,:) ]% DEBUG
                %[PolyOrd_riMAT(rMIX,:);   	PolyOrd_riMAT_2(rMIX_2,:) ]% DEBUG
            end
    else% NOT in *_2
        PolyOrd_nMIXMAT_2   = [PolyOrd_nMIXMAT_2;   PolyOrd_nMIXMAT(rMIX,:)];
        PolyOrd_riMAT_2     = [PolyOrd_riMAT_2;     PolyOrd_riMAT(rMIX,:)];
        PolyOrd_coefVEC_2 	= [PolyOrd_coefVEC_2;   1];
    end
    %----------------------------------------------------------------- 
end

%% ######################################################
function [ isFOUND ] = isSAME_Permute( Ord_VEC, ...
    mixVEC, riVEC, mixVEC2, riVEC2 )

ordPERM = perms( Ord_VEC );
mixPERM = perms( mixVEC );
riPERM  = perms( riVEC );

isFOUND = 0;
for nPERM = 1 : size( mixPERM, 1)
	ordBOOL	= (ordPERM(nPERM,:) == Ord_VEC);
    if isempty(find(ordBOOL == 0))% all 1's
        %------------------------------         
     	mixBOOL	= (mixPERM(nPERM,:) == mixVEC2);
        riBOOL 	= (riPERM(nPERM,:)  == riVEC2);
        if isempty(find(mixBOOL == 0)) && isempty(find(riBOOL == 0))% all 1's
            isFOUND = 1;
            break;
        end
        %------------------------------         
    end
end