function [ Wnr ] = INL_Wnr( N, Opt_Disp)
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

ord_FACTORIAL = FactorialVec([1:N]);
%polynomial product: cVn1Vn2 * dVn1Vn2 = cd Vn1^2 Vn2^2 = [2@position_n1  2@position_n2]
%       ADD vector of power of each Vn	:   [2@position_n1  2@position_n2] 	:row in OrdPwr_MAT
%       MULTIPLY coef of prod           :   cd                            	:entry in c_VEC
%       which Vn in product             :   [n1             n2]             :row in Ord_MAT
%       expand as Vn1 Vn1 Vn2 Vn2       :   [n1 n1 n2 n2]                   :row in PolyOrd_MAT
%----------------------------------------------------------
%Wnr.OrdPwr_MAT{n,r}                [ Vn^Pwr ] = [n1 ... nr]
%Wnr.c_VEC{n,r}                     ([Multiplicant])
%   .Ord_MAT(remove bc implicit)    position cC of non-zero entry in OrdPwr_MAT
%----------------------------------------------------------
%Wnr.PolyOrd_MAT{n,1}   k = [Multiplicant Vr1-Ord ... Vrn-Ord] = [n1 n1 n2 n2]
%  	 PolyDeg_MAT        implicit: [1...1]
%Wnr.cFCT_VEC{n,1}      calc iNL for NLTF: n!/([1!^k1 ... n!^kn]) .* [k1! ... kn!]) * limited-Arithm-Avg( H(f1)H(f1,f2) )
%                       normally: n! * Arithm-Avg( H(f1)H(f1,f2) )
if(Opt_Disp)
	sprintf('c \t cFCT \t OrdPwr')
end

% Wnr.OrdPwr_MAT: {3x3 cell}
%      Wnr.c_VEC: {3x3 cell}
%   Wnr.cFCT_VEC: {3x3 cell}
%Wnr.PolyOrd_MAT: {3x3 cell}
%% ########################### Wnr{n,r}.OrdPwr_MAT
for n = 1 : N
    if(Opt_Disp) disp(['%============================================================ n=' num2str(n)]); end
    Wnr.OrdPwr_MAT{n,1}  	= zeros(1,N);   Wnr.OrdPwr_MAT{n,1}(n)	= 1;
    Wnr.c_VEC{n,1}          = [1];
    Wnr.cFCT_VEC{n,1}   	= factorial(n);
    Wnr.PolyOrd_MAT{n,1}	= [n];
    %Wnr.PolyDeg_MAT{n,1}	= [1];
for r = 2 : n
    if(Opt_Disp) disp(['%----------------------------- (n,r)=' num2str([n r])]); end
    OrdPwr_MAT	= [];
    c_VEC       = [];
	cFCT_VEC    = [];
    PolyOrd_MAT = [];
%============================================================ OrdPwr_MAT, c_VEC
for nI = 1 : min([n-r+1 N])
    if(Opt_Disp)
        [[nI 1]   [n-nI r-1]]% DEBUG
    end
    %[s_SymCell{n}(1:nI) s_SymCell{n}(nI+1:end)]
    %wnr_tempVEC = [w{nI,1} w{n-nI,r-1}]
    %
    %[sym(findsym(w{nI,1})) sym(findsym(w{n-nI,r-1}))]
    %wnr_tempVEC = [subs(w{nI,1},   sym(findsym(w{nI,1})),     s_SymCell{n}(1:nI)) ...
    %               subs(w{n-nI,r-1},sym(findsym(w{n-nI,r-1})),s_SymCell{n}(nI+1:end))]
	MAT1	= Wnr.OrdPwr_MAT{nI,1};
    MAT2    = Wnr.OrdPwr_MAT{n-nI,r-1};
    VEC1	= Wnr.c_VEC{nI,1};
    VEC2	= Wnr.c_VEC{n-nI,r-1};
    wH  = [];
    cH  = [];
	for n1 = 1 : size(MAT1,1)
    for n2 = 1 : size(MAT2,1)
        wH(size(wH,1)+1,:)  = MAT1(n1,:) + MAT2(n2,:);% ADD vector of power of each Vn
        cH(size(cH,1)+1,1)	= VEC1(n1,1) * VEC2(n2,1);% MULTIPLY coef of prod
    end
    end
    %Remove redundancy in OrdPwr_MAT, starting from wH
    %[wnr_IDX2	wnr_IDX2_	wH_IDX2	wH_IDX2_]   = Find_VecIDX_Func( OrdPwr_MAT, wH,'MATRIX',[],0);
    %    isequal( wnr_IDX2, wnr_IDX )
    %    isequal( wnr_IDX2_, wnr_IDX_ )
    %    isequal( wH_IDX2, wH_IDX )
    %    isequal( wH_IDX2_, wH_IDX_ )
    [wnr_IDX	wnr_IDX_	wH_IDX	wH_IDX_]    = Find_VecIDX( OrdPwr_MAT, wH,'MATRIX','Not symSUBnum',[],0);
    c_VEC(wnr_IDX)	= c_VEC(wnr_IDX) + cH(wH_IDX);% existing
    OrdPwr_MAT    	= [OrdPwr_MAT;  wH(wH_IDX_,:)];% new
    c_VEC         	= [c_VEC;       cH(wH_IDX_,1)];% new
end
    Wnr.OrdPwr_MAT{n,r} = OrdPwr_MAT;
    Wnr.c_VEC{n,r}      = c_VEC;
%============================================================ PolyOrd_MAT, cFCT_VEC
for rC = 1 : size(OrdPwr_MAT,1)
        PolyOrd_VEC = [];
        %PolyDeg_VEC = [];
        %         ([n1! ... nr!] = [1!^k1 ... n!^kn]) .* [k1! ... kn!]
        cFCT	= (ord_FACTORIAL .^ OrdPwr_MAT(rC,:)) .* FactorialVec(OrdPwr_MAT(rC,:));% 
        cFCT	= cFCT( find(cFCT ~= 0) );
        cFCT	= prod( cFCT );
        %m  	= OrdPwr_MAT(rC,k)
        %cFCT   = cFCT * (factorial(k))^m * factorial(m);
   	for cC = 1 : size(OrdPwr_MAT,2)
       	if(OrdPwr_MAT(rC,cC)~=0)
          	PolyOrd_VEC     = [PolyOrd_VEC	repmat(cC,[1 OrdPwr_MAT(rC,cC)])];
          	%PolyDeg_VEC  	= [PolyDeg_VEC	repmat(1, [1 OrdPwr_MAT(rC,cC)])];
        end
  	end
        PolyOrd_MAT(rC,:)   = PolyOrd_VEC;
        %PolyDeg_MAT(rC,:)	= PolyDeg_VEC;
        cFCT_VEC            = [cFCT_VEC;    cFCT];
end
    Wnr.PolyOrd_MAT{n,r}	= PolyOrd_MAT;
    %Wnr.PolyDeg_MAT{n,r}	= PolyDeg_MAT;
    Wnr.cFCT_VEC{n,r}       = cFCT_VEC;
%============================================================ 
    if(Opt_Disp)
        %sprintf('%d \t %d \n',[1 2; 12 13]')
        [c_VEC      cFCT_VEC    OrdPwr_MAT]% DEBUG
        PolyOrd_MAT% DEBUG
        %PolyDeg_MAT% DEBUG
    end
end
end

%w % celldisp(w)
%c % celldisp(c)
%cSIZE % celldisp(cSIZE)
%cFCT% celldisp(cFCT)
