%% ###################################################### MIX, Wnr, Fp, Mn, Fm
%measure 1-tone + 2-tone response: find order N
N = 3;% 3;%
Q = 2;
    [ MIX ] = Mix_Qtone_Sym( N, Q, struct('HD',{'wHD'}, 'fListOrd',{'ascend'}), Opt_Disp);
%------------------------------ Poly
[ Wnr ]         = INL_Wnr( N, Opt_Disp);
[ Fp  Fp_ ]     = INL_Poly( N, MIX, Wnr, Opt_Disp);% Fp_{:}
[ Fp2 ]         = INL_Poly_Condense( Fp, Wnr, MIX, 'ALL', 0);
%------------------------------ Mult
[ Mn  Fm  Fm_ ] = INL_Mult( N, MIX, Opt_Disp);% Fm_{:}
[ Fm2 ]         = INL_Mult_Condense( Fm, Mn, MIX, 'ALL', 0);

%MIX.(fmix/HD/SYM_BD, Idx:BD<->ALL, Idx:BD<->RCD)
[ MIX ] = Mix_BandDiv( MIX );
[ MIX ] = Mix_BandSYM2( MIX, 1);

%% ###################################################### THESIS Latex
Fresp.fRESP_MAT = [2    0];% [-1   1];% [1   1];% 
Fresp.fRESP_MAT = [0    3];% [1    0];% [2  -1];% [2    1];% 
    %[ RCD_IDX ] = Mix_Select( fRESP_MAT, MIX, 1);
    %[ Fp2    ] = INL_Poly_Condense( Fp, Wnr, 'Select', MIX, RCD_IDX, 5);
%------------------------------ Wnr -> NLTF
    Print_INL_NLTF_Wnr( Wnr, 5, 'INL_NLTF');
%------------------------------ Poly
	Print_INL_Poly( Fresp.fRESP_MAT, [1:5], MIX, Wnr, Fp, Fp2, 'INL_DirCalc', 1);
%------------------------------ Mult
	Print_INL_Mult( Fresp.fRESP_MAT, [1:5], MIX, Mn, Fm, Fm2, 'INL_DirCalc', 1);

%% ###################################################### Define Circuit
%========================================================== Lin
%Ckt.Name = 'DiffpairSBalMix';% DiffPair SBal Mixer 
%Ckt.CharCEL_Ymat    = { 'gL+s*cL'       '0'          	'-gT'; ...
%                        '0'             'gL+s*cL'    	'-gT'; ...
%                        '0'             '0'          	'-2*gT' };
Ckt.CharCEL_Ymat    = { 'G'          	'0'          	'-gT'; ...
                        '0'             'G'             '-gT'; ...
                        '0'             '0'          	'-2*gT' };
Ckt.CharCEL_ILIN	= { '-gT*Vi/2'      'gT*Vi/2'  	    'Is' };%'Is-gT*Vi/2+gT*Vi/2'
%----------------------------------------------------------
Ckt.CharCEL_Vdep 	= { 'Vo1'         	'Vo2'           'Ve' };
%--------------------------
Ckt.CharCEL_Vsrc	= {'Vi' 'Is'};
Ckt.CharCEL_VsrcTone = {'Vi' 'Is'};% {A1 A2}->creat voltage spectral (#source <= #tone), {'Vin' 'Vin'} if 2tone in same source
%--------------------------
%Ckt.CharCEL_R    	= {'gT' 'gL' 'cL'};% freqIndep
Ckt.CharCEL_R       = {'gT'};% freqIndep
%--------------------------
Ckt.CharCEL_Z       = {'G'};% freqDep ('s' 'S' SubSYM/SubNUM as 'k*f1+l*f2', offlimits)
%========================================================== NL
Ckt.INL_types     	= {'poly'};% creat
Ckt.INL_Vdep_type	= {{'poly'}       	{'poly'}       	{'poly'     'poly'}};% {} if no INL
Ckt.INL_Vdep_eo  	= {{'eo'}         	{'eo'}          {'eo'       'eo'}};
Ckt.INL_Vdep_Sign 	= {[-1]             [-1]            [-1       	-1]};
Ckt.INL_Vdep_gNL  	= {{'gT'}         	{'gT'}      	{'gT'       'gT'}};% No Sign, only SYM
%----------
Ckt.INL_Vdep        = {{'Vi/2-Ve'}      {'-Vi/2-Ve'}    {'Vi/2-Ve'  '-Vi/2-Ve'}};
Ckt.INL_Vdep_SymCEL	= {{{'Ve'}}       	{{'Ve'}}      	{{'Ve'}     {'Ve'}}};% creat
Ckt.INL_Vdep_IDX	= {{[3]}           	{[3]}         	{[3]        [3]}};% creat
Ckt.INL_Vsrc_SymCEL	= {{{'Vi'}}       	{{'Vi'}}      	{{'Vi'}     {'Vi'}}};% creat
Ckt.INL_Vsrc_IDX	= {{[1]}          	{[1]}         	{[1]        [1]}};% creat
%Ckt.INL_eVdep     	= [0                0               3];% creat from INL_eo
%Ckt.INL_oVdep     	= [0                0               3];% creat from INL_eo


%========================================================== Lin
%Ckt.Name = 'RFreceiver';
Ckt.CharCEL_Ymat    = { '1/Z1+1/Za'	'0'      	'0'         '0'         '0'         '0'; ...
                        'A'      	'1/Zh'     	'0'         '0'         '0'         '0'; ...
                        '0'       	'H'       	'-1'        '0'         '0'         '0'; ...
                        '0'       	'0'       	'0'         '1/Z2+1/Zb'	'0'         '0'; ...
                        '0'       	'0'       	'0'         'B'         '1/Zm2'   	'0'; ...
                        '0'       	'0'       	'0'         '0'         '0'         '1'};
Ckt.CharCEL_ILIN	= { 'V1/Z1' 	'0'       	'0'         'V2/Z2'     '0'       	'0'};
%Ckt.CharCEL_Ymat    = { 'G1+Ga'     '0'      	'0'         '0'         '0'         '0'; ...
%                        'A'      	'Gh'     	'0'         '0'         '0'         '0'; ...
%                        '0'       	'H'       	'-1'        '0'         '0'         '0'; ...
%                        '0'       	'0'       	'0'         'G2+Gb'     '0'         '0'; ...
%                        '0'       	'0'       	'0'         'B'         'Gm2'   	'0'; ...
%                        '0'       	'0'       	'0'         '0'         '0'         '1'};
%Ckt.CharCEL_ILIN	= { 'V1*G1'  	'0'       	'0'         'V2*G2'   	'0'       	'0'};
%----------------------------------------------------------
Ckt.CharCEL_Vdep 	= { 'Va'      	'Vh'     	'Vm1'       'Vb'        'Vm2'       'Vm3'};
%--------------------------
Ckt.CharCEL_Vsrc	= {'V1' 'V2'};
Ckt.CharCEL_VsrcTone = {'V1' 'V2'};% {A1 A2}->creat voltage spectral (#source <= #tone), {'Vin' 'Vin'} if 2tone in same source
%--------------------------
Ckt.CharCEL_R       = {};% freqIndep
%--------------------------
Ckt.CharCEL_Z     	= {'Z1' 'Z2' 'Za' 'Zb' 'Zh' 'A' 'B' 'H' 'Zm2'};% freqDep ('s' 'S' SubSYM/SubNUM as 'k*f1+l*f2', offlimits)
%Ckt.CharCEL_Z       = {'G1' 'G2' 'Ga' 'Gb' 'Gh' 'A' 'B' 'H' 'Gm2'};% freqDep ('s' 'S' SubSYM/SubNUM as 'k*f1+l*f2', offlimits)
%========================================================== NL
Ckt.INL_types     	= {'poly' 'multiply'};% creat
Ckt.INL_Vdep_type	= {{'poly'}   	{'poly'}  	{}          {'poly'}  	{'poly'}  	{'multiply'}};% {} if no INL
Ckt.INL_Vdep_eo  	= {{'eo'}     	{'eo'}    	{}          {'eo'}    	{'eo'}      {'eo'}};
Ckt.INL_Vdep_Sign 	= {[-1]      	[-1]     	[]          [-1]     	[-1]     	[1]};
Ckt.INL_Vdep_gNL  	= {{'az'}      	{'ag'}      {}      	{'bz'}      {'bg'}      {'m'}};% No Sign, only SYM
%----------
Ckt.INL_Vdep        = {{'Va'}    	{'Va'}    	{}          {'Vb'}    	{'Vb'}    	{'Vm1';     'Vm2'}};
Ckt.INL_Vdep_SymCEL	= {{{'Va'}}   	{{'Va'}}    {{}}        {{'Vb'}} 	{{'Vb'}}    {{'Vm1'};   {'Vm2'}}};% creat
Ckt.INL_Vdep_IDX	= {{[1]}        {[1]}     	{[]}      	{[4]}     	{[4]}     	{[3];       [5]}};% creat
Ckt.INL_Vsrc_SymCEL	= {{{}}         {{}}        {{}}        {{}}        {{}}        {{};        {}}};% creat
Ckt.INL_Vsrc_IDX	= {{[]}      	{[]}      	{[]}      	{[]}      	{[]}      	{[];        []}};% creat

%% ###################################################### 
Fresp.fRESP_MAT = [ 0    0; -1    1;  1    1;  2    0;  0    2];% 2nd
Fresp.fRESP_MAT = [ 1    0;  0    1;  2   -1;  2    1; -1    2;  1    2;  3    0;  0    3];% 3rd
[ Fresp ]   = Fresp_SelectFMIX( Fresp, 'fRESP_MAT', Fp2, MIX, Wnr, 1,1);%Opt_Print, Opt_Disp

%% ###################################################### Ckt
Ckt.N = N;
Ckt.Q = Q;
[ Ckt ]     = Ckt_Gen2( Ckt, Fresp, MIX, 1);
%------------------------------
[ Ckt ]     = Ckt_SolnLin3( Ckt, Fresp, MIX, 1);
%------------------------------
tic
[ Ckt ]     = Ckt_SolnNL4( Ckt, Fresp,    MIX, Wnr, Mn, Fp2, Fm2, 1 );
toc% n=3:7.2sec n=5:529sec
%------------------------------
[ Ckt ]     = Ckt_Soln2( Ckt, Fresp, 1 );

if(0)
    FileNam = ['SymVolt_' Ckt.Name '_' Fresp.Name ...
                '_Q' num2str(Q) 'N' num2str(N) '.mat']
    if exist( FileNam,'file')
        FileNam	= input([ FileNam ' exists, enter another: '], 's');
    end
	save( FileNam, 'N','Q','Fresp','Ckt', ...
                   'MIX','Wnr','Fp','Fp_','BD')
end
end