function [ MIX ] = Mix_BandDiv( MIX, ...
    Meas, Fig, fHz, S21, Opt)
%=========================================== Input
%Meas.Qtone_Mhz   	= [ 500     900 ];
%Meas.Qtone_swpMAX  = [ 0       40  ];
%=========================================== Output
%MIX.IdxBD_ALL	= [];% =[nBD  nMIX_BD]              xxx_ALL's ptr to xxx_BD
%MIX.IdxBD_RCD	= {};%{ n }(nMIX,:) =[nBD  nMIX_BD]	xxx_RCD's ptr to xxx_BD
%------------------------------
%MIX.fmix_BD 	= {};%{ nBD }(nMIX_BD,:)           {[0] [fc] [HDn]}
%MIX.fmixHD_BD	= {};%{ nBD }(nMIX_BD)             {[0] [fc] [HDn]}
%MIX.fmixSYM_BD	= {};%{ nBD }(nMIX_BD)             {[0] [fc] [HDn]}
%------------------------------
%MIX.IdxALL_BD	= {};%{ nBD } =[nMIX]               xxx_BD's  ptr to xxx_ALL
%MIX.IdxRCD_BD	= {};%{ nBD }{nMIX_BD} =[n  nMIX]	xxx_BD's ptr to xxx_RCD (for Build Chart)
%   	lowest ord 1st by construction

if ismember({'Fig','fHz','S21','Opt'},who)% exist('S21','var')
%############################################################################################################
switch Meas.Qtone_swp
    case{'1Carr_DfNarrow'}
        f1f2VEC_Hz = (Meas.Qtone_Mhz + Meas.Qtone_swpMAX/2 * [-1 1]) *1e6;
        f1f2CEL_Hz = mat2cell( f1f2VEC_Hz, ones(size(f1f2VEC_Hz,1),1), ones(size(f1f2VEC_Hz,2),1));
    case{'2Carr'}
        f1f2CEL_Hz = mat2cell( Meas.Qtone_Mhz*1e6, ones(size(Meas.Qtone_Mhz,1),1), ones(size(Meas.Qtone_Mhz,2),1));
end
%============================================= MIX.(fmixSYM_ALL  ->  fmixNUM_ALL)
MIX.fmixNUM_ALL	= [];
for nMIX = 1 : length( MIX.fmixSYM_ALL )
    if( (MIX.fmixSYM_ALL(nMIX) ~= 0) )% && (sum(MIX.fmixMAT_ALL(nMIX,:)) >= 0) take only +Freqs, but some -EnvFreq may =0
        %MIX.fmixSYM_ALL(nMIX)% DEBUG
        %---------------------------- Meth 1
        [Expr_SymCHAR	Expr_SymCEL     SymCEL_IDX  ] = ExprSUBsym_Func( MIX.fmixSYM_ALL(nMIX), MIX.fSymCEL);
        [Expr_MatCEL                                ] = ExprSUBnum_Func( SymCEL_IDX, f1f2CEL_Hz, 'LOOPvecELEM');
        MIX.fmixNUM_ALL( nMIX )     = ExprEVALnum_Func( MIX.fmixSYM_ALL(nMIX), Expr_SymCHAR, Expr_MatCEL);
        %---------------------------- Meth 2
        %fMIXnum_nMIX 	= ExprEVALnum_Func( MIX.fmixSYM_ALL(nMIX), 'f2, f3', f1f2CEL_Hz);
        %----------------------------
    end
end
    %MIX.fmixSYM_ALL.'% DEBUG
    %MIX.fmixNUM_ALL% DEBUG
%============================================= MIX.fmixNUM_ALL  ->  fmixNUM_2
[fmixNUM_2  Idx2] = sort(MIX.fmixNUM_ALL, 'ascend');% Idx2 = Ptr to original
    fmixNUM_2(1:end-1:end)%DEBUG
%============================================= S21 -> fHzDiv
Opt.fmin	= fmixNUM_2(1);
Opt.fmax    = fmixNUM_2(end) * 1.1;
[ fHzDiv  fHz_  S21_ ] = S21_BandDiv( fHz, S21, 0, Opt);% Fig
        plot_Sio_Func2( fHz_, S21_, [Fig+1], ...
        'dB',{'yLin'},{'xLog'},{}, ...
        {''},{'Hz'},{'dB' 'deg'},{'S21'}, ...
        ['-k.'],'0-Fig')%[],
    %############################## plot ALL Band-Divisions
if(Opt.PlotAllBandDiv)
    for nMIX = 1 : length( fHzDiv )
        plot_Sio_Func2( [fHzDiv(nMIX)  fHzDiv(nMIX)], [0  1], [Fig+1], ...
        'dB',{'yLin'},{'xLog'},{}, ...
        {''},{'Hz'},{},{''}, ...%'Band Index'
        ['--k.'],'0-Fig')%,[]
    end
end
%============================================= 
switch Meas.Qtone_swp
    case{'1Carr_DfNarrow'}% DONT need fHz, S21
        [ MIX ] = OneCarr_DfNarrow( MIX, Fig );
    case{'2Carr'}
        [ MIX ] = TwoCarr( MIX, Fig, fmixNUM_2, fHzDiv );
end
%############################################################################################################
else
	[ MIX ] = OneCarr_DfNarrow( MIX );
end

%% ============================================= print MIX.xxx_BD
disp(['################################################# print MIX.xxx_BD'])
for nBD = 1 : length( MIX.fmix_BD )
    temp = sprintf('------------------------------------------------------nBD=%3d', nBD);
    disp(temp)
	%[MIX.fmix_BD{nBD}	MIX.fmixHD_BD{nBD}      MIX.fmixSYM_BD{nBD}]% DEBUG
for nMIX_BD = 1 : size( MIX.fmix_BD{nBD},1 )
    temp = sprintf('%3d  %3d    %3d    %10s',...
        MIX.fmix_BD{nBD}(nMIX_BD,1),  MIX.fmix_BD{nBD}(nMIX_BD,2),  MIX.fmixHD_BD{nBD}(nMIX_BD),  ...
        char( MIX.fmixSYM_BD{nBD}(nMIX_BD)) );
    disp(temp)
end
end

%============================================= print MIX.IdxRCD_BD
disp(['################################################# print MIX.IdxRCD_BD'])
Print_Mix_BD( MIX.IdxRCD_BD, MIX, 'IdxRCD_BD');

%% ###################################################### '1Carr_DfNarrow' DONT need fHz, S21
function [ MIX ] = OneCarr_DfNarrow( MIX, Fig )
    
%============================================= xxx_ALL <=> xxx_BD
MIX.IdxBD_ALL	= [];% =[nBD  nMIX_BD]      xxx_ALL's ptr to xxx_BD
%MIX.IdxALL_BD	= {};% { nBD } =[nMIX]      xxx_BD's  ptr to xxx_ALL
%MIX.fmix_BD   	= {};% { nBD }(nMIX_BD,:)   {[0] [fc] [HDn]}
%MIX.fmixHD_BD	= {};% { nBD }(nMIX_BD)     {[0] [fc] [HDn]}
%MIX.fmixSYM_BD	= {};% { nBD }(nMIX_BD)     {[0] [fc] [HDn]}
%fmixNUM_BD    	= {};
    for nBD = 1 : MIX.N + 1
        MIX.IdxALL_BD{nBD} 	= [];%Init
        MIX.fmix_BD{nBD}   	= [];%Init
        MIX.fmixHD_BD{nBD}	= [];%Init
        MIX.fmixSYM_BD{nBD}	= [];%Init
        fmixNUM_BD{nBD}   	= [];%Init
    end
for nMIX = 1 : length( MIX.fmixHD_ALL )
    nBD     = MIX.fmixHD_ALL( nMIX ) + 1;% HD + 1
    %-----------------------------------
    if isfield( MIX,'fmixNUM_ALL');
        fmixNUM_BD{ nBD }	= [fmixNUM_BD{ nBD };  MIX.fmixNUM_ALL(nMIX)];
    end
    %-----------------------------------
    MIX.IdxALL_BD{ nBD }    = [MIX.IdxALL_BD{ nBD };    nMIX];
    MIX.fmix_BD{ nBD }      = [MIX.fmix_BD{ nBD };      MIX.fmix_ALL(nMIX,:)];
    MIX.fmixHD_BD{ nBD }    = [MIX.fmixHD_BD{ nBD };    MIX.fmixHD_ALL(nMIX)];
    MIX.fmixSYM_BD{ nBD }   = [MIX.fmixSYM_BD{ nBD };   MIX.fmixSYM_ALL(nMIX)];
    %-----------------------------------
    MIX.IdxBD_ALL(nMIX,:)   = [nBD  length( MIX.IdxALL_BD{ nBD } )];
end
    %MIX.IdxBD_ALL% DEBUG
    %MIX.fmixSYM_ALL.'% DEBUG
%============================================= fmixNUM_BD -> 
if isfield( MIX,'fmixNUM_ALL');
    MIX.BD_fHzHi  	= [];
    MIX.BD_fHzLo    = [];
    for nBD = 1 : MIX.N + 1
        MIX.BD_fHzLo(nBD) = min( fmixNUM_BD{ nBD } );% - Meas.Qtone_swpMAX/2
        MIX.BD_fHzHi(nBD) = max( fmixNUM_BD{ nBD } );% + Meas.Qtone_swpMAX/2
        %############################## plot SELECTED Band-Divisions
        if(nBD == 1)
            LegStrLO = 'Frequency Band Division, Lower';
            LegStrHI = 'Frequency Band Division, Upper';
        else
            LegStrLO = '';
            LegStrHI = '';
        end
        plot_Sio_Func2( [MIX.BD_fHzLo(nBD)  MIX.BD_fHzLo(nBD)], [-30  25], [Fig+1], ...%[0  nBD]
            'dB',{'yLin'},{'xLog'},{}, ...
            {''},{'Hz'},{},{LegStrLO}, ...
            ['--b>'],'0-Fig')%,[]
        plot_Sio_Func2( [MIX.BD_fHzHi(nBD)  MIX.BD_fHzHi(nBD)], [-30  25], [Fig+1], ...%[0  nBD]
            'dB',{'yLin'},{'xLog'},{}, ...
            {''},{'Hz'},{},{LegStrHI}, ...
            ['--b<'],'0-Fig')%,[]
    end
end
%============================================= 
MIX.IdxBD_RCD	= {};%{ n   }(nMIX,:)  =[nBD  nMIX_BD]	xxx_RCD's ptr to xxx_BD
MIX.IdxRCD_BD   = {};%{ nBD }{nMIX_BD} =[n    nMIX]   	xxx_BD's ptr to xxx_RCD (for Build Chart)
    for nBD = 1 : length( MIX.fmix_BD )
    for nMIX_BD = 1 : size( MIX.fmix_BD{nBD},1 )
        MIX.IdxRCD_BD{nBD}{nMIX_BD}  = [];
    end
    end
for n = 1 : MIX.N
    MIX.IdxBD_RCD{n} = [];
for nMIX = 1 : size( MIX.fmix_RCD{n},1 )
    nMIX_ALL	= MIX.fmix_RCDIDX2{n}(nMIX);
    %-----------------------------------
    MIX.IdxBD_RCD{n}(nMIX,:) = MIX.IdxBD_ALL( nMIX_ALL,: );
    %-----------------------------------
    nBD     = MIX.IdxBD_ALL( nMIX_ALL,1 );
    nMIX_BD = MIX.IdxBD_ALL( nMIX_ALL,2 );
    MIX.IdxRCD_BD{nBD}{nMIX_BD} = [MIX.IdxRCD_BD{ nBD }{nMIX_BD};	[n nMIX]];%lowest ord 1st by construction
end
    %MIX.IdxBD_RCD{n}% DEBUG
    %MIX.fmixSYM_RCD{n}.'% DEBUG
end
%============================================= plot fIM
for nMIX = 1 : length( MIX.fmixHD_ALL )
    nBD     = MIX.IdxBD_ALL(nMIX,1);% MIX.IdxBD_ALL(nMIX,:) =[nBD  nMIX_BD]
    nMIX_BD = MIX.IdxBD_ALL(nMIX,2);
    n       = MIX.IdxRCD_BD{ nBD }{nMIX_BD}(1,1);%MIX.IdxRCD_BD{ nBD }{nMIX_BD}=[n    nMIX] lowest ord 1st by construction
    nMIX_RCD= MIX.IdxRCD_BD{ nBD }{nMIX_BD}(1,2);
    %-----------------------------------
    if isfield( MIX,'fmixNUM_ALL');
      	%PlotOpt = struct('Ln_Width',2,'Mkr_Size',8,'Font_Name','Times', 'Font_Size',12,'Font_Size_Leg',12,'Font_Weight','normal');
       	plot_Sio_Func2( [MIX.fmixNUM_ALL(nMIX)  MIX.fmixNUM_ALL(nMIX)], [0  n], [Fig+1], ...%[0  nBD]
                'dB',{'yLin'},{'xLog'},{}, ...
                {''},{'Hz'},{},{''}, ...
                ['-ro'],'0-Fig')% ,[],PlotOpt Stem not apply to LOG plot
    end
end

%% ###################################################### '2Carr'
function [ MIX ] = TwoCarr( MIX, Fig, fmixNUM_2, fHzDiv )

%============================================= fHz_Idx: fmixNUM_2's ptr/index to fHzDiv, reordered, condensed 
fHz_Idx     = [];
for nMIX = 1 : length( MIX.fmixSYM_ALL )
    DIVidx = find( fHzDiv >= fmixNUM_2(nMIX), 1, 'first');
    if isempty(DIVidx)
        disp('outside upper freq-range');
        fmixNUM_2(nMIX)% DEBUG
        DIVidx = length( fHzDiv );
    end
	fHz_Idx(nMIX) = DIVidx;
end
    fHz_Idx% DEBUG
[fHz_Idx  xVEC_IDX  xVEC_count  xVEC_IDXcel] = MatRowCondens( fHz_Idx.', []);
%============================================= MIX.BD_fHzHi/Lo: fHzDiv in fHz_Idx
MIX.BD_fHzHi  	= [];
MIX.BD_fHzLo    = [];
for nBD = 1 : length( fHz_Idx )
    MIX.BD_fHzHi(nBD)	= fHzDiv( fHz_Idx(nBD) );
    if(fHz_Idx(nBD)-1 == 0)
        disp('outside lower freq-range');
        MIX.BD_fHzLo(nBD)	= 0;
    else
        MIX.BD_fHzLo(nBD)	= fHzDiv( fHz_Idx(nBD)-1 );
    end
	%############################## plot SELECTED Band-Divisions
        if(nBD == 1)
            LegStrLO = 'Frequency Band Division, Lower';
            LegStrHI = 'Frequency Band Division, Upper';
        else
            LegStrLO = '';
            LegStrHI = '';
        end
    plot_Sio_Func2( [MIX.BD_fHzLo(nBD)  MIX.BD_fHzLo(nBD)], [-10  25], [Fig+1], ...%[0  nBD]
        'dB',{'yLin'},{'xLog'},{}, ...
        {''},{'Hz'},{},{LegStrLO}, ...
        ['--b>'],'0-Fig')%,[]
    plot_Sio_Func2( [MIX.BD_fHzHi(nBD)  MIX.BD_fHzHi(nBD)], [-10  25], [Fig+1], ...%[0  nBD]
        'dB',{'yLin'},{'xLog'},{}, ...
        {''},{'Hz'},{},{LegStrHI}, ...
        ['--b<'],'0-Fig')%,[]
end
    [MIX.BD_fHzHi;  MIX.BD_fHzLo]% DEBUG ;  MIX.BD_fHzHi-MIX.BD_fHzLo
    (MIX.BD_fHzHi - MIX.BD_fHzLo) /1e6% DEBUG
%============================================= MIX.IdxALL_BD
MIX.IdxBD_ALL	= [];% =[nBD  nMIX_BD]      xxx_ALL's ptr to xxx_BD
%MIX.IdxALL_BD	= {};% { nBD } =[nMIX]      xxx_BD's  ptr to xxx_ALL
%MIX.fmix_BD  	= {};% { nBD }(nMIX_BD,:)   {[0] [fc] [HDn]}
%MIX.fmixHD_BD	= {};% { nBD }(nMIX_BD)     {[0] [fc] [HDn]}
%MIX.fmixSYM_BD	= {};% { nBD }(nMIX_BD)     {[0] [fc] [HDn]}
    for nBD = 1 : length( MIX.BD_fHzHi )
        MIX.IdxALL_BD{nBD}      = [];%Init
        MIX.fmix_BD{nBD}        = [];%Init
        MIX.fmixHD_BD{nBD}      = [];%Init
        MIX.fmixSYM_BD{nBD}     = [];%Init
    end
%============================================= MIX.IdxBD_ALL: fmixNUM_ALL's ptr/index to MIX.BD_fHzHi
for nMIX = 1 : length( MIX.fmixSYM_ALL )
    nBD = find( MIX.BD_fHzHi >= MIX.fmixNUM_ALL(nMIX), 1, 'first');
    if isempty(nBD)
        disp('outside upper freq-range');
        MIX.fmixNUM_ALL(nMIX)% DEBUG
        nBD = length( MIX.BD_fHzHi );
    end
    %-----------------------------------
	MIX.IdxBD_ALL(nMIX,1) = nBD;
    %-----------------------------------
    MIX.IdxALL_BD{ nBD }    = [MIX.IdxALL_BD{ nBD }; nMIX];
    MIX.fmix_BD{ nBD }      = [MIX.fmix_BD{ nBD }; MIX.fmix_ALL(nMIX,:)];
    MIX.fmixHD_BD{ nBD }    = [MIX.fmixHD_BD{ nBD }; MIX.fmixHD_ALL(nMIX)];
    MIX.fmixSYM_BD{ nBD }   = [MIX.fmixSYM_BD{ nBD }; MIX.fmixSYM_ALL(nMIX)];
    %-----------------------------------
    MIX.IdxBD_ALL(nMIX,2)   = length( MIX.IdxALL_BD{ nBD } );
end
    %MIX.IdxBD_ALL% DEBUG
    %MIX.fmixSYM_ALL.'% DEBUG
%============================================= MIX.IdxRCD_BD
MIX.IdxRCD_BD	= {};%{ nBD }{nMIX_BD} =[n    nMIX]  	xxx_BD's ptr to xxx_RCD (for Build Chart)
    for nBD = 1 : length( MIX.fmix_BD )
    for nMIX_BD = 1 : size( MIX.fmix_BD{nBD},1 )
        MIX.IdxRCD_BD{nBD}{nMIX_BD}  = [];
    end
    end
%============================================= MIX.IdxBD_RCD: fmix_RCD's ptr/index to MIX.BD_fHzHi
MIX.IdxBD_RCD	= {};%{ n }(nMIX,:)    =[nBD  nMIX_BD]	xxx_RCD's ptr to xxx_BD
for n = 1 : MIX.N
    MIX.IdxBD_RCD{n} = [];
for nMIX = 1 : size( MIX.fmix_RCD{n},1 )
    nMIX_ALL    = MIX.fmix_RCDIDX2{n}(nMIX);
    %-----------------------------------
    MIX.IdxBD_RCD{n}(nMIX,:) = MIX.IdxBD_ALL( nMIX_ALL,: );
    %-----------------------------------
    nBD     = MIX.IdxBD_ALL( nMIX_ALL,1 );
    nMIX_BD = MIX.IdxBD_ALL( nMIX_ALL,2 );
    MIX.IdxRCD_BD{nBD}{nMIX_BD} = [MIX.IdxRCD_BD{ nBD }{nMIX_BD};	[n nMIX]];%lowest ord 1st by construction
end
    %MIX.IdxBD_RCD{n}% DEBUG
    %MIX.fmixSYM_RCD{n}.'% DEBUG
end
%============================================= plot fIM
for nMIX = 1 : length( MIX.fmixSYM_ALL )
    nBD     = MIX.IdxBD_ALL(nMIX,1);% MIX.IdxBD_ALL(nMIX,:) =[nBD  nMIX_BD]
    nMIX_BD = MIX.IdxBD_ALL(nMIX,2);
    n       = MIX.IdxRCD_BD{ nBD }{nMIX_BD}(1,1);%MIX.IdxRCD_BD{ nBD }{nMIX_BD}=[n    nMIX] lowest ord 1st by construction
    nMIX_RCD= MIX.IdxRCD_BD{ nBD }{nMIX_BD}(1,2);
    %-----------------------------------
        plot_Sio_Func2( [MIX.fmixNUM_ALL(nMIX)  MIX.fmixNUM_ALL(nMIX)], [0  n], [Fig+1], ...%[0  nBD]
        'dB',{'yLin'},{'xLog'},{}, ...
        {''},{'Hz'},{},{''}, ...
        ['-ro'],'0-Fig')%,[]
end

%% ###################################################### Scrap
if(0)


[ MIX ] = Mix_Qtone_Sym( 3, 2, struct('HD',{'wHD'}, 'fListOrd',{'ascend'}, 'Disp',{1}) );
%------------------------------must clear all
Meas.Qtone_swp      = '1Carr_DfNarrow';
Meas.Qtone_Mhz    	= [ 900 ];
Meas.Qtone_swpMAX   = [ 40 ];
[ MIX ] = Mix_BandDiv( MIX, Meas, 98); 
%------------------------------must clear all
FileNam = ['C:\Documents and Settings\jhu\My Documents\lv8\Data\UPC1678GV\FreqResp\' ...
    'UPC1678GV_1-8001Mhz_-30dBmAtt20_1Khz_16001pts10ms.s2p'];
[fHz  Snp  Header] = Read_SnP_Func( FileNam, 2, struct('IOformat',{'dB2dB'},'IOPortConv',{'ADSPNA2port_2_Gen'}));
%fHz     = fHz(1:4000);
%Snp{3}	= Snp{3}(1:4000);
Meas.Qtone_swp      = '2Carr';
Meas.Qtone_Mhz   	= [ 500     900 ];
[ MIX ] = Mix_BandDiv( MIX, Meas, 100, fHz, Snp{3}, struct('Type',{'dB'},'Val',{0.5})); 
%------------------------------
[ MIX ] = Mix_BandSYM( MIX, 1);

end