function [ mix_MAT	fmix_MAT	fmixHD_VEC	fmixSYM_VEC     mixCoef_VEC ...
                    fmix_RCD	fmixHD_RCD	fmixSYM_RCD ] = Mix_Qtone(...
            Q, mix_fSymVEC, fSymVEC, fNumVEC, n, ...
            Opt, Opt_Disp)
        % mix_CEL	fmix_CEL	fmixHD_CEL	fmixSYM_CEL     mixCoef_CEL 
%----------------------------
% mix_fSymVEC	= [-f3 -f2 f2 f3] 	Symbolic Freq
% fSymVEC       = [        f2 f3]  	Symbols in Symbolic Freq
% fNumVEC       = [        #  # ]  	Numeric-Val in Symbolic Freq
% Opt           = struct('PosFreq',{1}, 'HD',{'wHD'}, 'Sort',{'fMIX'}, 'fListOrd',{'ascend'}, 'Disp',{1})
%----------------------------
% mix_MAT       = [ MIXve=[m1 m2 m3 m4] ]
% fmixSYM_VEC	= [ mixVEC * mix_fSymVEC.']( to get numeric value: sub(fmixSYM_VEC, fSymVEC, fNumVEC) )   
% fmixSYM_VEC, mixCount_VEC, mixCoef_VEC: [ROWs]
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

switch Opt.HD
    case {'No_HD'}
        n_UpLim = n-1;
    otherwise% {'wHD'}
     	n_UpLim = n;
end

if ~isfield(Opt, 'fListOrd')
	Opt.fListOrd = 'descend';
end

%% ###########################
mix_MAT   	= [];% [4x4 double]  [10x4 double]  [20x4 double]
fmix_MAT  	= [];% [4x2 double]  [10x2 double]  [20x2 double]
fmixHD_VEC	= [];% [4x1 double]  [10x1 double]  [20x1 double]
fmixSYM_VEC = [];% [4x1 sym]     [10x1 sym]     [20x1 sym]
mixCount_VEC = [];
mixCoef_VEC = [];% [4x1 double]  [10x1 double]  [20x1 double]
switch Q
    %==================================================================
    case{1} %Q=1 for 1-tone, thus mix_MAT = [m1 m2]
for m1 = 0 : n_UpLim
for m2 = 0 : n_UpLim
        mixVEC      = [m1 m2];
    if (sum(mixVEC,2) == n)
        mix_MAT 	= [mix_MAT;         mixVEC];
    end
end
end
    %==================================================================
    case{2} %Q=2 for 2-tone, thus mix_MAT = [m1 m2 m3 m4]
for m1 = 0 : n_UpLim
for m2 = 0 : n_UpLim
for m3 = 0 : n_UpLim
for m4 = 0 : n_UpLim
        mixVEC      = [m1 m2 m3 m4];
    if (sum(mixVEC,2) == n)
        mix_MAT     = [mix_MAT;         mixVEC];
    end
end
end
end
end
    %==================================================================
    case{3} %Q = 3 for 3-tone, thus mix_MAT = [m1 m2 m3 m4 m5 m6]
for m1 = 0 : n_UpLim
for m2 = 0 : n_UpLim
for m3 = 0 : n_UpLim
for m4 = 0 : n_UpLim
for m5 = 0 : n_UpLim
for m6 = 0 : n_UpLim
        mixVEC      = [m1 m2 m3 m4 m5 m6];
    if (sum(mixVEC,2) == n)
        mix_MAT 	= [mix_MAT;     	mixVEC];
    end
end
end
end
end
end
end
    %==================================================================
    otherwise
        disp('Q > 3'); return;
    %==================================================================
end

for offset = 1 : length(fSymVEC)
	tone_p = length(fSymVEC) + offset;
	tone_n = length(fSymVEC) + 1 - offset;
	fmix_MAT(:,offset) = mix_MAT(:,tone_p) - mix_MAT(:,tone_n);
end
    fmixHD_VEC      = sum( fmix_MAT, 2);
	fmixSYM_VEC     = mix_MAT * mix_fSymVEC.';
	mixCount_VEC    = Multinomial(mix_MAT, n);% fmix Coef
    mixCoef_VEC     = mixCount_VEC / 2^n;
    
%% ########################### sort (Real,Conj) Freq 
%x(1) subs fNumVEC: !=0 (Real,Conj) pairs + NOT symmetric about fmix=0
%                   ==0 (Real,Conj) pairs + NOT in pairs
%     NOT always even# fmix, can't split in middle ----> take out fmix=0
%     OK for fmix_MAT, INCORR for mix_MAT
% (2) fmix_MAT(Real)=[k l] ----> fmix_MAT(Conj)=[k l]*-1
% (3) mix_MAT(Real)=[m2_ m1_ m1 m2] ----> mix_MAT(Conj)=[m2 m1 m1_ m2_]
%###### Opt.Sort = 'fMIX'
[fmixNUM_VEC	idx] = sort( single( subs(fmixSYM_VEC, fSymVEC, fNumVEC) ),Opt.fListOrd);
    mix_MAT         = mix_MAT(idx,:);
    fmix_MAT        = fmix_MAT(idx,:);
    fmixHD_VEC      = fmixHD_VEC(idx);
    fmixSYM_VEC     = fmixSYM_VEC(idx);
	mixCoef_VEC     = mixCoef_VEC(idx);
    mixCount_VEC    = mixCount_VEC(idx);
Num_MixVec_ALL  = factorial(2*Q+n-1) / factorial(n) / factorial(2*Q-1);
Num_MixVec      = size(mix_MAT,1);
if(Opt_Disp)
end

%###### Opt.PosFreq
ZeroIDX	= find( fmixSYM_VEC == 0 );
if ~isempty( ZeroIDX )
    ConjIDX = (1                        : ZeroIDX(1)-1          );
    RealIDX = (ZeroIDX(end)+1           : length(fmixSYM_VEC)   );
else
	ConjIDX = (1                        : length(fmixSYM_VEC)/2 );
	RealIDX = (length(fmixSYM_VEC)/2+1	: length(fmixSYM_VEC)   );
end
    mix_CEL         = { mix_MAT(RealIDX,:)      flipud(mix_MAT(ConjIDX,:))      };
    fmix_CEL        = { fmix_MAT(RealIDX,:)     flipud(fmix_MAT(ConjIDX,:))     };
    fmixHD_CEL      = { fmixHD_VEC(RealIDX,:)	flipud(fmixHD_VEC(ConjIDX,:))   };
    fmixSYM_CEL     = { fmixSYM_VEC(RealIDX,:)	flipud(fmixSYM_VEC(ConjIDX,:))	};
	%mixCoef_CEL     = { mixCoef_VEC(RealIDX,:)	flipud(mixCoef_VEC(ConjIDX,:))	};
    %mixCount_CEL    = { mixCount_VEC(RealIDX,:)	flipud(mixCount_VEC(ConjIDX,:))	};
    
if(Opt_Disp)
    disp(['%---------------------------- sort (Real,Conj) Freq'])% DEBUG
    [Num_MixVec_ALL    Num_MixVec	length(fmixSYM_CEL{1})  length(fmixSYM_CEL{2})	length(ZeroIDX)]
    %temp1	= [mix_MAT      fmixSYM_VEC     fmix_MAT	fmixHD_VEC      fmixSYM_VEC     mixCount_VEC	mixCoef_VEC     ];
    %   if ~IsINT_Func2( length(fmixSYM_VEC)/2 )
    %       temp1
    %   end
    %tempR	= [mix_CEL{1}	fmixSYM_CEL{1}	fmix_CEL{1}	fmixHD_CEL{1}	fmixSYM_CEL{1}	mixCount_CEL{1}	mixCoef_CEL{1}  ];
    %tempI	= [mix_CEL{2}	fmixSYM_CEL{2}	fmix_CEL{2}	fmixHD_CEL{2}	fmixSYM_CEL{2}	mixCount_CEL{2}	mixCoef_CEL{2}  ];
    %temp2	= [flipud(tempI);	tempR];
    mixR = mix_CEL{1};      mixI = mix_CEL{2};	mixI = [fliplr(mixI(:,length(fSymVEC)+1:end ))   fliplr(mixI(:,1:length(fSymVEC) ))];
    if ~isequal( mixR,mixI )% ~isequal( temp1, temp2 )
        disp('Mix_Qtone: INCORR for mix_MAT (bc Diff-MixVec in mix_MAT, can give Same-Freq in fmix_MAT)')
        [ mixR	fmixSYM_CEL{1}      mixI  fmixSYM_CEL{2} ]
    end
    fmixR =  fmix_CEL{1};	fmixI = -fmix_CEL{2};
    if ~isequal( fmixR,fmixI )
        disp('Mix_Qtone: Error in fmix_MAT')
        [ fmixR	fmixSYM_CEL{1}      fmixI  fmixSYM_CEL{2} ]
    end
end

%% ########################### RCD
fmix_RCD        = {};% [2x2 double]  [5x2 double]  [8x2 double]
fmix_RCDIDX     = {};% 
%fmix_RCDIDX2    = {};% [1 2]  [3 4 5 6 7]  [8 1 2 9 10 11 12 13]
fmix_RCDIDXcel	= {};% 
fmixHD_RCD    	= {};% [2x1 double]  [5x1 double]  [8x1 double]
fmixSYM_RCD  	= {};% [2x1 sym]  [5x1 sym]  [8x1 sym]

[fmix_RCD, fmix_RCDIDX, xVEC_count, fmix_RCDIDXcel] = MatRowCondens( fmix_CEL{1} );
%fmix_RCD{2}    	= fmix_CEL{2}( fmix_RCDIDX );
    fmixHD_RCD      = fmixHD_CEL{1}( fmix_RCDIDX );
    %fmixHD_RCD{2}	= fmixHD_CEL{2}( fmix_RCDIDX );
    fmixSYM_RCD     = fmixSYM_CEL{1}( fmix_RCDIDX );
    %fmixSYM_RCD{2}	= fmixSYM_CEL{2}( fmix_RCDIDX );
if ~isempty( ZeroIDX )
    fmix_RCD    = [fmix_MAT(ZeroIDX(1),:);      fmix_RCD    ];
    fmixHD_RCD  = [fmixHD_VEC(ZeroIDX(1),:);    fmixHD_RCD  ];
    fmixSYM_RCD	= [fmixSYM_VEC(ZeroIDX(1),:);	fmixSYM_RCD ];
end

if(Opt_Disp)
    disp(['%---------------------------- fmix_RCD'])% DEBUG
	[fmix_RCD                       fmixSYM_RCD                         fmixHD_RCD                  ]
	%[fmix_RCD{1}	fmix_RCD{2}     fmixSYM_RCD{1}	fmixSYM_RCD{2}      fmixHD_RCD{1}	fmixHD_RCD{2}]
    [ length( fmixSYM_RCD ) ]
end
%% ########################### TEST
if (0)
    
if isfield(Opt, 'PosFreq')
if Opt.PosFreq
    idx         = find( single( subs(fmixSYM_VEC, fSymVEC, fNumVEC) ) > 0 );
    mix_MAT     = mix_MAT(idx,:);
    fmix_MAT	= fmix_MAT(idx,:);
    fmixSYM_VEC	= fmixSYM_VEC(idx);
	mixCoef_VEC	= mixCoef_VEC(idx);    mixCount_VEC = mixCount_VEC(idx);
end
end

switch Opt.Sort
    %==================================================================
    case {'fMIXcoef'}
        % Re-Arrange
        mix_MAT         = flipud(mix_MAT);
        fmixSYM_VEC    	= fliplr(fmixSYM_VEC);
        mixCount_VEC	= fliplr(mixCount_VEC);
        mixCoef_VEC 	= fliplr(mixCoef_VEC);
        [mixCoef_VEC idx] = sort(mixCoef_VEC, 'descend');
        fmixSYM_VEC    	= fmixSYM_VEC(idx);
    %==================================================================
    case {'fMIX'}
        if isa(mix_fSymVEC, 'numeric')
            [fmixSYM_VEC idx]	= sort(fmixSYM_VEC, 'descend');
        else
            %fmixSYM_VEC
            %fSymVEC
            %fNumVEC
            %subs(fmixSYM_VEC, fSymVEC, fNumVEC)
            [fmixNUM_VEC	idx] = sort( single( subs(fmixSYM_VEC, fSymVEC, fNumVEC) ),Opt.fListOrd);
            fmixSYM_VEC     = fmixSYM_VEC(idx);
        end
            mixCoef_VEC     = mixCoef_VEC(idx);
	%==================================================================
    otherwise
        disp('Unknow Opt.Sort');
	%==================================================================
end

    Q = 1;  % for 1-tone, thus mix_MAT = [m1 m2]
        mix_fSymVEC = [-f1 f1];
    Q = 2;  % for 2-tone, thus mix_MAT = [m1 m2 m3 m4]
        mix_fSymVEC = [-f2 -f1 f1 f2];
    n = 1
    [mix_MAT fmixSYM_VEC mixCoef_VEC] = Mix_2tone(Q, mix_fSymVEC, n);
Q=1
n=1
%[   1,   0, -f1,   1, 1/2]
%[   0,   1,  f1,   1, 1/2]
n=2
%[     1,     1,     0,     2,   1/2]
%[     2,     0, -2*f1,     1,   1/4]
%[     0,     2,  2*f1,     1,   1/4]
n=3
%[     2,     1,   -f1,     3,   3/8]
%[     1,     2,    f1,     3,   3/8]
%[     3,     0, -3*f1,     1,   1/8]
%[     0,     3,  3*f1,     1,   1/8]
n=4
%[     0,     4,  4*f1,     1,  1/16]
%[     1,     3,  2*f1,     4,   1/4]
%[     2,     2,     0,     6,   3/8]
%[     3,     1, -2*f1,     4,   1/4]
%[     4,     0, -4*f1,     1,  1/16]
n=5
%[     0,     5,  5*f1,     1,  1/32]
%[     1,     4,  3*f1,     5,  5/32]
%[     2,     3,    f1,    10,  5/16]
%[     3,     2,   -f1,    10,  5/16]
%[     4,     1, -3*f1,     5,  5/32]
%[     5,     0, -5*f1,     1,  1/32]

Q=2
n=1
%[   1,   0,   0,   0, -f2,   1, 1/2]
%[   0,   1,   0,   0, -f1,   1, 1/2]
%[   0,   0,   1,   0,  f1,   1, 1/2]
%[   0,   0,   0,   1,  f2,   1, 1/2]
n=2
%[      1,      1,      0,      0, -f2-f1,      2,    1/2]
%[      1,      0,      1,      0, -f2+f1,      2,    1/2]
%[      1,      0,      0,      1,      0,      2,    1/2]
%[      0,      1,      1,      0,      0,      2,    1/2]
%[      0,      1,      0,      1, -f1+f2,      2,    1/2]
%[      0,      0,      1,      1,  f1+f2,      2,    1/2]
%[      2,      0,      0,      0,  -2*f2,      1,    1/4]
%[      0,      2,      0,      0,  -2*f1,      1,    1/4]
%[      0,      0,      2,      0,   2*f1,      1,    1/4]
%[      0,      0,      0,      2,   2*f2,      1,    1/4]
n=3
%[        1,        1,        1,        0,      -f2,        6,      3/4]
%[        1,        1,        0,        1,      -f1,        6,      3/4]
%[        1,        0,        1,        1,       f1,        6,      3/4]
%[        0,        1,        1,        1,       f2,        6,      3/4]
%[        2,        1,        0,        0, -2*f2-f1,        3,      3/8]
%[        2,        0,        1,        0, -2*f2+f1,        3,      3/8]
%[        2,        0,        0,        1,      -f2,        3,      3/8]
%[        1,        2,        0,        0, -f2-2*f1,        3,      3/8]
%[        1,        0,        2,        0, -f2+2*f1,        3,      3/8]
%[        1,        0,        0,        2,       f2,        3,      3/8]
%[        0,        2,        1,        0,      -f1,        3,      3/8]
%[        0,        2,        0,        1, -2*f1+f2,        3,      3/8]
%[        0,        1,        2,        0,       f1,        3,      3/8]
%[        0,        1,        0,        2, -f1+2*f2,        3,      3/8]
%[        0,        0,        2,        1,  2*f1+f2,        3,      3/8]
%[        0,        0,        1,        2,  f1+2*f2,        3,      3/8]
%[        3,        0,        0,        0,    -3*f2,        1,      1/8]
%[        0,        3,        0,        0,    -3*f1,        1,      1/8]
%[        0,        0,        3,        0,     3*f1,        1,      1/8]
%[        0,        0,        0,        3,     3*f2,        1,      1/8]
n=3
%[        0,        0,        0,        3,     3*f2,        1,      1/8]
%[        0,        0,        1,        2,  f1+2*f2,        3,      3/8]
%[        0,        0,        2,        1,  2*f1+f2,        3,      3/8]
%[        0,        0,        3,        0,     3*f1,        1,      1/8]
%[        0,        1,        0,        2, -f1+2*f2,        3,      3/8]
%[        1,        0,        0,        2,       f2,        3,      3/8]
%[        0,        1,        1,        1,       f2,        6,      3/4]
%[        1,        0,        1,        1,       f1,        6,      3/4]
%[        0,        1,        2,        0,       f1,        3,      3/8]
%[        1,        0,        2,        0, -f2+2*f1,        3,      3/8]
%[        0,        2,        0,        1, -2*f1+f2,        3,      3/8]
%[        1,        1,        0,        1,      -f1,        6,      3/4]
%[        0,        2,        1,        0,      -f1,        3,      3/8]
%[        2,        0,        0,        1,      -f2,        3,      3/8]
%[        1,        1,        1,        0,      -f2,        6,      3/4]
%[        2,        0,        1,        0, -2*f2+f1,        3,      3/8]
%[        0,        3,        0,        0,    -3*f1,        1,      1/8]
%[        1,        2,        0,        0, -f2-2*f1,        3,      3/8]
%[        2,        1,        0,        0, -2*f2-f1,        3,      3/8]
%[        3,        0,        0,        0,    -3*f2,        1,      1/8]
n = 5
%[          0,          0,          0,          5,       5*f2,          1,       1/32]
%[          0,          0,          1,          4,    f1+4*f2,          5,       5/32]
%[          0,          0,          2,          3,  2*f1+3*f2,         10,       5/16]
%[          0,          0,          3,          2,  3*f1+2*f2,         10,       5/16]
%[          0,          0,          4,          1,    4*f1+f2,          5,       5/32]
%[          0,          0,          5,          0,       5*f1,          1,       1/32]
%[          0,          1,          0,          4,   -f1+4*f2,          5,       5/32]
%[          0,          1,          1,          3,       3*f2,         20,        5/8]
%[          1,          0,          0,          4,       3*f2,          5,       5/32]
%[          0,          1,          2,          2,    f1+2*f2,         30,      15/16]
%[          1,          0,          1,          3,    f1+2*f2,         20,        5/8]
%[          0,          1,          3,          1,    2*f1+f2,         20,        5/8]
%[          1,          0,          2,          2,    2*f1+f2,         30,      15/16]
%[          0,          1,          4,          0,       3*f1,          5,       5/32]
%[          1,          0,          3,          1,       3*f1,         20,        5/8]
%[          1,          0,          4,          0,   -f2+4*f1,          5,       5/32]
%[          0,          2,          0,          3, -2*f1+3*f2,         10,       5/16]
%[          0,          2,          1,          2,   -f1+2*f2,         30,      15/16]
%[          1,          1,          0,          3,   -f1+2*f2,         20,        5/8]
%[          0,          2,          2,          1,         f2,         30,      15/16]
%[          1,          1,          1,          2,         f2,         60,       15/8]
%[          2,          0,          0,          3,         f2,         10,       5/16]
%[          0,          2,          3,          0,         f1,         10,       5/16]
%[          1,          1,          2,          1,         f1,         60,       15/8]
%[          2,          0,          1,          2,         f1,         30,      15/16]
%[          1,          1,          3,          0,   -f2+2*f1,         20,        5/8]
%[          2,          0,          2,          1,   -f2+2*f1,         30,      15/16]
%[          2,          0,          3,          0, -2*f2+3*f1,         10,       5/16]
%[          0,          3,          0,          2, -3*f1+2*f2,         10,       5/16]
%[          0,          3,          1,          1,   -2*f1+f2,         20,        5/8]
%[          1,          2,          0,          2,   -2*f1+f2,         30,      15/16]
%[          0,          3,          2,          0,        -f1,         10,       5/16]
%[          1,          2,          1,          1,        -f1,         60,       15/8]
%[          2,          1,          0,          2,        -f1,         30,      15/16]
%[          1,          2,          2,          0,        -f2,         30,      15/16]
%[          2,          1,          1,          1,        -f2,         60,       15/8]
%[          3,          0,          0,          2,        -f2,         10,       5/16]
%[          2,          1,          2,          0,   -2*f2+f1,         30,      15/16]
%[          3,          0,          1,          1,   -2*f2+f1,         20,        5/8]
%[          3,          0,          2,          0, -3*f2+2*f1,         10,       5/16]
%[          0,          4,          0,          1,   -4*f1+f2,          5,       5/32]
%[          0,          4,          1,          0,      -3*f1,          5,       5/32]
%[          1,          3,          0,          1,      -3*f1,         20,        5/8]
%[          1,          3,          1,          0,   -f2-2*f1,         20,        5/8]
%[          2,          2,          0,          1,   -f2-2*f1,         30,      15/16]
%[          2,          2,          1,          0,   -2*f2-f1,         30,      15/16]
%[          3,          1,          0,          1,   -2*f2-f1,         20,        5/8]
%[          3,          1,          1,          0,      -3*f2,         20,        5/8]
%[          4,          0,          0,          1,      -3*f2,          5,       5/32]
%[          4,          0,          1,          0,   -4*f2+f1,          5,       5/32]
%[          0,          5,          0,          0,      -5*f1,          1,       1/32]
%[          1,          4,          0,          0,   -f2-4*f1,          5,       5/32]
%[          2,          3,          0,          0, -2*f2-3*f1,         10,       5/16]
%[          3,          2,          0,          0, -3*f2-2*f1,         10,       5/16]
%[          4,          1,          0,          0,   -4*f2-f1,          5,       5/32]
%[          5,          0,          0,          0,      -5*f2,          1,       1/32]

    Q = 1;  % for 1-tone, thus mix_MAT = [m1 m2]
        mix_fSymVEC = [-10 10];
    %###################
    Q = 2;  % for 2-tone, thus mix_MAT = [m1 m2 m3 m4]
        mix_fSymVEC = [-11 -10 10 11];
    n = 3;
    [mix_MAT fmixSYM_VEC mixCoef_VEC] = Mix_2tone(Q, mix_fSymVEC, n);
Q=1 
n=2
%[   1,   1,   0,   2, 1/2]
%[   2,   0, -20,   1, 1/4]
%[   0,   2,  20,   1, 1/4]
n=3
%[   2,   1, -10,   3, 3/8]
%[   1,   2,  10,   3, 3/8]
%[   3,   0, -30,   1, 1/8]
%[   0,   3,  30,   1, 1/8]

Q=2
n=2 %Num_MixVec = 10
%[   1,   1,   0,   0, -21,   2, 1/2]
%[   1,   0,   1,   0,  -1,   2, 1/2]
%[   0,   1,   1,   0,   0,   2, 1/2]
%[   1,   0,   0,   1,   0,   2, 1/2]
%[   0,   1,   0,   1,   1,   2, 1/2]
%[   0,   0,   1,   1,  21,   2, 1/2]
%[   2,   0,   0,   0, -22,   1, 1/4]
%[   0,   2,   0,   0, -20,   1, 1/4]
%[   0,   0,   2,   0,  20,   1, 1/4]
%[   0,   0,   0,   2,  22,   1, 1/4]
n=3 %Num_MixVec = 20
%[   1,   1,   1,   0, -11,   6, 3/4]
%[   1,   1,   0,   1, -10,   6, 3/4]
%[   1,   0,   1,   1,  10,   6, 3/4]
%[   0,   1,   1,   1,  11,   6, 3/4]
%[   2,   1,   0,   0, -32,   3, 3/8]
%[   1,   2,   0,   0, -31,   3, 3/8]
%[   2,   0,   1,   0, -12,   3, 3/8]
%[   2,   0,   0,   1, -11,   3, 3/8]
%[   0,   2,   1,   0, -10,   3, 3/8]
%[   0,   2,   0,   1,  -9,   3, 3/8]
%[   1,   0,   2,   0,   9,   3, 3/8]
%[   0,   1,   2,   0,  10,   3, 3/8]
%[   1,   0,   0,   2,  11,   3, 3/8]
%[   0,   1,   0,   2,  12,   3, 3/8]
%[   0,   0,   2,   1,  31,   3, 3/8]
%[   0,   0,   1,   2,  32,   3, 3/8]
%[   3,   0,   0,   0, -33,   1, 1/8]
%[   0,   3,   0,   0, -30,   1, 1/8]
%[   0,   0,   3,   0,  30,   1, 1/8]
%[   0,   0,   0,   3,  33,   1, 1/8]
%#################################################
% check
n_chos_m = [];
for n_1 = 1 : size(fm_m,1)
    n_chos_m(n_1) = Multinomial(fm_m(n_1,:), n);
end
n_chos_m
%#################################################
% poly-mult = conv, fast way to find mixCount_VEC
f_poly = ones(1,length(mix_fSymVEC))
n = 3
mixCount_VEC = f_poly;
for n1 = 1 : n-1
    mixCount_VEC = conv(mixCount_VEC, f_poly);
end
mixCount_VEC
%#################################################
% don't work b.c PolyMult, not ADD
fmixSYM_VEC  = [];
mixCount_VEC = [];
fm_m = [];
for m1 = 0 : n
    m2 = n - m1;
    %for m2 = 0 : n
    %if (m1 + m2 == n)
    fm_temp = [m1 m2] * mix_fSymVEC.'
    idx = find(fmixSYM_VEC == fm_temp);
	if isempty(idx)
        fmixSYM_VEC = [fmixSYM_VEC fm_temp];
        mixCount_VEC = [mixCount_VEC 1];
        fm_m = [fm_m; [m1 m2]];
    else
        mixCount_VEC(idx) = mixCount_VEC(idx) + 1;
    end
end
fmixSYM_VEC
mixCount_VEC
fm_m
%#################################################
end