function [ MIX ] = Mix_Qtone_Sym( N, Q, Opt, Opt_Disp)
% for Q < 2-Tone only
%----------------------------
% mix_fSymVEC	= [-f2 -f1 f1 f2] 	Symbolic Freq
% fSymVEC       = [        f1 f2]  	Symbols in Symbolic Freq
% fSymCEL       = {        f1 f2}
% fNumVEC       = [        #  # ]  	Numeric-Val in Symbolic Freq
% Opt           = struct('PosFreq',{1}, 'HD',{'wHD'}, 'Sort',{'fMIX'}, 'fListOrd',{'ascend'}, 'Disp',{1})
%----------------------------
% fMIXnum_nMIX      =  [fIMD] of size (nDF, 1)
% MIX.fmixNUM_ALL	= [[fIMD=fMIXnum_nMIX] ...] of size (nDF, nIMD), created from [f1 f2] of size (nDF, Q)
% ToDO: IDX according to n
%
% fxVEC_nDF = MIX.fmixNUM_ALL( nDF,: ) RowCondensed
% fxCEL_Mhz = { nDF }[ nIMD ]
%
% fxVEC     = sub(fmixSYM_VEC, fVECsym, fNumVEC)       numeric freq value
if ~exist('Opt_Disp','var')
    Opt_Disp = 0;
end

    Nord    = N;
    Nfreq   = CumSum( Q );
    Ntone   = Q;
Buss_Sym
switch Q
    %==================================================================
    case{1} %Q=1 for 1-tone, thus mix_MAT = [m1 m2]
    MIX.mix_fSymVEC	= [-fc fc];
    MIX.fNumVEC     = [ 200 ];%{-200,200}
    %==================================================================
    case{2} %Q=2 for 2-tone, thus mix_MAT = [m1 m2 m3 m4]
    MIX.mix_fSymVEC	= [-f2 -f1  f1  f2];
    MIX.fNumVEC     = [ 200, 201 ];% {-201,-200,200,201}
    %==================================================================
    case{3} %Q = 3 for 3-tone, thus mix_MAT = [m1 m2 m3 m4 m5 m6]
    MIX.mix_fSymVEC	= [-f3 -f2 -f1  f1  f2  f3];
    MIX.fNumVEC     = [ 200, 201, 202 ];% {-202,-201,-200,200,201,202}
    %==================================================================
    otherwise
        disp('Q > 3'); return;
    %==================================================================
end
    MIX.fSymVEC     = MIX.mix_fSymVEC( length(MIX.mix_fSymVEC)/2+1 : end);
    MIX.fSymCEL     = SYMvec2SYMcel( MIX.fSymVEC );

%% ######################################################
MIX.N   = N;
MIX.Q   = Q;
%----------------------------------------------------------------------
MIX.mix_MAT    	= {};% {[4x4 double]  [10x4 double]  [20x4 double]}
MIX.fmix_MAT   	= {};% {[4x2 double]  [10x2 double]  [20x2 double]}
MIX.fmixHD_VEC	= {};% {[4x1 double]  [10x1 double]  [20x1 double]}
MIX.fmixSYM_VEC	= {};% {[4x1 sym]     [10x1 sym]     [20x1 sym]}
MIX.mixCoef_VEC	= {};% {[4x1 double]  [10x1 double]  [20x1 double]}
%----------------------------------------------------------------------
MIX.fmix_RCD        = {};% {[2x2 double]  [5x2 double]  [8x2 double]} 
MIX.fmixHD_RCD    	= {};% {[2x1 double]  [5x1 double]  [8x1 double]}
MIX.fmixSYM_RCD  	= {};% {[2x1 sym]  [5x1 sym]  [8x1 sym]}
MIX.fmix_RCDIDX     = {};% {}
MIX.fmix_RCDIDX2    = {};% ptr to xxx_ALL  {[1 2]  [3 4 5 6 7]  [8 1 2 9 10 11 12 13]}  
MIX.fmix_RCDIDXcel	= {};% {}
%----------------------------------------------------------------------
MIX.fmix_ALL        = [];% [13x2 double]
MIX.fmixHD_ALL   	= [];% [13x1 double]
MIX.fmixSYM_ALL    	= [];% [13x1 sym]
MIX.fmix_ALLIDXcel	= {};% ptr to xxx_RCD  {1x13 cell}
%----------------------------------------------------------------------

%switch Q
	%==================================================================
	%case{1} %Q=1 for 1-tone, thus mix_MAT = [m1 m2]
%for n = 1 : N
%    MIX.fmixNUM_ALL  	= [MIX.fmixNUM_ALL     f1f2CEL_Hz{1} * n];
%end
	%fxCEL_Mhz   = mat2cell( MIX.fmixNUM_ALL, ones(size(MIX.fmixNUM_ALL,1),1),  ones(size(MIX.fmixNUM_ALL,2),1) );
    %==================================================================
	%case{2} %Q=2 for 2-tone, thus mix_MAT = [m1 m2 m3 m4]
for n = 1 : N
    if(Opt_Disp)
        disp(['%################################################# n=' int2str(n)])% DEBUG
    end
    %[MIX.mix_MAT(n,:)	MIX.fmix_MAT(n,:)	MIX.fmixHD_VEC(n,:)     MIX.fmixSYM_VEC(n,:)	MIX.mixCoef_VEC(n,:) ...
    [MIX.mix_MAT{n}     MIX.fmix_MAT{n}     MIX.fmixHD_VEC{n}       MIX.fmixSYM_VEC{n}      MIX.mixCoef_VEC{n} ...
                        MIX.fmix_RCD{n}     MIX.fmixHD_RCD{n}       MIX.fmixSYM_RCD{n} ] = ...
            Mix_Qtone(Q, MIX.mix_fSymVEC, MIX.fSymVEC, MIX.fNumVEC, n, Opt, Opt_Disp);
        %disp(['_RCDIDXcel => mix_MAT above'])
        %MIX.fmix_RCDIDXcel{n}% DEBUG
        %disp(['%================================================= fmix_ALL'])
%MIX.fmix_RCDIDX2    = {};% {[1 2]  [3 4 5 6 7]  [8 1 2 9 10 11 12 13]}
%    [ALL_IDX2	ALLXOR_IDX2	 RCD_IDX2	RCDXOR_IDX2] = Find_VecIDX_Func( ...
%        MIX.fmix_ALL, MIX.fmix_RCD{n}, 'MATRIX', [], 0);
%    isequal( ALL_IDX2, ALL_IDX )
%    isequal( ALLXOR_IDX2, ALLXOR_IDX )
%    isequal( RCD_IDX2, RCD_IDX )
%    isequal( RCDXOR_IDX2, RCDXOR_IDX )
    [ALL_IDX	ALLXOR_IDX	RCD_IDX     RCDXOR_IDX] = Find_VecIDX( ...
        MIX.fmix_ALL, MIX.fmix_RCD{n}, 'MATRIX', 'Not symSUBnum', [],0);
   	MIX.fmix_RCDIDX2{n}(RCD_IDX)      = ALL_IDX;
   	MIX.fmix_RCDIDX2{n}(RCDXOR_IDX)   = length( MIX.fmix_ALL ) + [1 : length(RCDXOR_IDX)];
        %%MIX.fmix_ALL% DEBUG
        %%MIX.fmix_RCD{n}% DEBUG
        %ALL_IDX% DEBUG
        %RCD_IDX% DEBUG
        %RCDXOR_IDX% DEBUG
        %disp(['_RCDIDX2 => fmix_ALL below'])
        %MIX.fmix_RCDIDX2{n}% DEBUG
	%disp(['%---------------------------- fmix_ALLIDXcel back-ptr'])
%MIX.fmix_ALL          	= [];% [13x2 double]
%MIX.fmix_ALLIDXcel    	= {};% {1x13 cell}
%MIX.fmixSYM_ALL       	= [];% [13x1 sym]
    for nRCD = 1 : length( RCD_IDX )
        MIX.fmix_ALLIDXcel{ALL_IDX(nRCD)} = [MIX.fmix_ALLIDXcel{ALL_IDX(nRCD)}	[n;	RCD_IDX(nRCD)] ];
    end
    for nRCD = 1 : length( RCDXOR_IDX )
        MIX.fmix_ALLIDXcel{length(MIX.fmixSYM_ALL) + nRCD} = [n;	RCDXOR_IDX(nRCD)];
    end
    MIX.fmix_ALL	= [MIX.fmix_ALL;  	MIX.fmix_RCD{n}(RCDXOR_IDX,:)	];
    MIX.fmixHD_ALL	= [MIX.fmixHD_ALL;	MIX.fmixHD_RCD{n}(RCDXOR_IDX)	];
    MIX.fmixSYM_ALL	= [MIX.fmixSYM_ALL;	MIX.fmixSYM_RCD{n}(RCDXOR_IDX)	];
        %MIX.fmix_ALL% DEBUG
        %MIX.fmixSYM_ALL% DEBUG
        %disp(['_ALLIDXcel => fmix_RCD above'])
        %MIX.fmix_ALLIDXcel% DEBUG
        %[ MIX.fmix_ALLIDXcel{:} ]% DEBUG
end
    %==================================================================
	%case{3} %Q = 3 for 3-tone, thus mix_MAT = [m1 m2 m3 m4 m5 m6]
	%==================================================================
	%otherwise
    %    disp('Q > 3'); return;
	%==================================================================
%end

%% ######################################################
if(0)

	%    disp(['%---------------------------- fmix_RCD'])% DEBUG
    %[MIX.fmix_RCD{n}, MIX.fmix_RCDIDX{n}, xVEC_count, MIX.fmix_RCDIDXcel{n}] = MatRowCondens( MIX.fmix_MAT{n} );
    %MIX.fmixSYM_RCD{n}  = MIX.fmixSYM_VEC{n}( MIX.fmix_RCDIDX{n} );
    %    [MIX.fmix_RCD{n}   MIX.fmixSYM_RCD{n}.']% DEBUG
    %    size( MIX.fmix_RCD{n}, 1 )

end