function [] = plot_Sio_Func2( x, y, fig, ...
    dBMaRi, yScaleCEL, xScaleCEL, AxisVecCEL, ...
  	titleCEL, xLabelCEL, yLabelCEL, legendCEL, ...
 	LineSpec, Opt_Fig, Opt, ...
    PlotOpt)
% By default, MATLAB resets the ColorOrder and LineStyleOrder properties each time you call plot. 
% If you want changes made to these properties persist, then define these changes as default values.
% set(0,'DefaultAxesColorOrder',[0 0 0],    'DefaultAxesLineStyleOrder','-|-.|--|:')
if ~exist('PlotOpt','var')
    %PlotOpt = struct('Ln_Width',2,'Mkr_Size',14,'Font_Name','Times', 'Font_Size',30,'Font_Size_Leg',24,'Font_Weight','normal');
    PlotOpt = struct('Ln_Width',2,'Mkr_Size',6,'Font_Name','Times', 'Font_Size',14,'Font_Size_Leg',14,'Font_Weight','normal');
    %PlotOpt = struct('Ln_Width',2,'Mkr_Size',6,'Font_Name','Times', 'Font_Size',20,'Font_Size_Leg',20,'Font_Weight','normal');
elseif isempty( PlotOpt )
    %PlotOpt = struct('Ln_Width',2,'Mkr_Size',14,'Font_Name','Times', 'Font_Size',30,'Font_Size_Leg',24,'Font_Weight','normal');
    PlotOpt = struct('Ln_Width',2,'Mkr_Size',6,'Font_Name','Times', 'Font_Size',14,'Font_Size_Leg',14,'Font_Weight','normal');
end
%--------------------------------------------------
if ~exist('Opt_Fig','var')
    Opt_Fig         = '1-Fig';
end
switch Opt_Fig
    case{'1-Fig','2-Fig'}
        nPLOT_end	= 2;
    otherwise% case{'0-Fig'}
        nPLOT_end	= 1;
end
%--------------------------------------------------ignored if not 'xLin' 'yLin'
if ~exist('Opt','var')
    Opt = struct('xDATA','yes', 'Stem','no');
elseif isempty( Opt )
    Opt = struct('xDATA','yes', 'Stem','no');
else
    if ~isfield(Opt,{'xDATA'})
        Opt.xDATA	= 'yes';
    end
	if ~isfield(Opt,{'Stem'})
        Opt.Stem	= 'no';
    end
end

% x: ROW/COL
% y: ROW/COL dim=1
%    MAT     dim=2 (plot each COL vs x)
%-------------------------
% IM spectral
% 1) stem/plot:	wo/xDATA, x =default index, y =across IM freq @each-power-level
% 2) semilogx:	x =IM freq, y =across IM freq @each-power-level
%% ###############################
if isempty( yScaleCEL )
    yScaleCEL	= {'yLin' 'yLin'};
elseif(length( yScaleCEL ) == 1)
    yScaleCEL	= {yScaleCEL{1} yScaleCEL{1}};
end

if isempty( xScaleCEL )
    xScaleCEL	= {'xLin' 'xLin'};
elseif(length( xScaleCEL ) == 1)
    xScaleCEL	= {xScaleCEL{1} xScaleCEL{1}};
end

if isempty( AxisVecCEL )
    AxisVecCEL	= {[] []};
elseif(length( AxisVecCEL ) == 1)
    AxisVecCEL	= {AxisVecCEL{1} AxisVecCEL{1}};
end

%-------------------------
if isempty( titleCEL )
    titleCEL	= {[] []};
elseif(length( titleCEL ) == 1)
    titleCEL	= {titleCEL{1} titleCEL{1}};
end

if isempty( xLabelCEL )
	xLabelCEL	= {[] []};
elseif(length( xLabelCEL ) == 1)
    xLabelCEL	= {xLabelCEL{1} xLabelCEL{1}};
end

if isempty( yLabelCEL )
    switch dBMaRi
        case {'VV'}
            yLabelCEL = {'(V)' '(Deg)'};
        case {'RI'}
            yLabelCEL = {'Re' 'Im'};
        case {'dB'}
            yLabelCEL = {'dB' 'Deg'};
        case {'MA'}
            yLabelCEL = {'Mag' 'Deg'};
        otherwise
            yLabelCEL = {[] []};
    end
elseif(length( yLabelCEL ) == 1)
    yLabelCEL	= {yLabelCEL{1} yLabelCEL{1}};
end

if isempty( legendCEL )
    legendCEL	= {[] []};
elseif(length( legendCEL ) == 1)
    legendCEL	= {legendCEL{1} legendCEL{1}};
end
%-------------------------
%% ##############################################
figure(fig)
for nPLOT = 1 : nPLOT_end
%%##############################################
    switch Opt_Fig
        case{'1-Fig'}
            subplot(1,2,nPLOT);
        otherwise
            if(nPLOT == 2)
                figure(fig + 1e6)
            end
    end
%%##############################################
    switch nPLOT
        case{1}
            Y = real(y);
        case{2}
            Y = imag(y);
    end
%%##############################################
switch Opt.xDATA
%==============================================================
    case{'yes'}
switch yScaleCEL{nPLOT}
	%-------------------------
    case{'yLin'}%RI parts: Lin Plots
        switch xScaleCEL{nPLOT}
            case {'xLin'}
                %===============================
                switch Opt.Stem
                    case{'no'}
                        plot(x,Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
                    otherwise
                        stem(x,Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
                end
                %===============================
            case {'xLog'}
                semilogx(x,Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
        end
	%-------------------------
    case{'yLogABS','yLog'}%RI parts: AbsLog Plots (support 'yLog', but no abs() may error)
        if isequal(yScaleCEL{nPLOT},'yLogABS')
        	Y = abs( Y );
        end
        switch xScaleCEL{nPLOT}
            case {'xLin'}
                semilogy(x,Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
            case {'xLog'}
                loglog(x,Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
        end
	%-------------------------
end
%==============================================================
    otherwise% case{'no'}
switch yScaleCEL{nPLOT}
	%-------------------------
    case{'yLin'}%RI parts: Lin Plots
        switch xScaleCEL{nPLOT}
            case {'xLin'}
                %===============================
                switch Opt.Stem
                    case{'no'}
                        plot(Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
                    otherwise
                        stem(Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
                end
                %===============================
            case {'xLog'}
                semilogx(Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
        end
	%-------------------------
    case{'yLogABS','yLog'}%RI parts: AbsLog Plots (support 'yLog', but no abs() may error)
        if isequal(yScaleCEL{nPLOT},'yLogABS')
        	Y = abs( Y );
        end
        switch xScaleCEL{nPLOT}
            case {'xLin'}
                semilogy(Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
            case {'xLog'}
                loglog(Y, LineSpec,'LineWidth',PlotOpt.Ln_Width,'MarkerSize',PlotOpt.Mkr_Size); grid on; hold on;
        end
	%-------------------------
end
%==============================================================
end
%%##############################################
    if ~isempty( AxisVecCEL{nPLOT} )
        axis( AxisVecCEL{nPLOT} );
    end
%%##############################################
	set(gca, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
    if ~isempty( titleCEL{nPLOT} )
    	title( titleCEL{nPLOT}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
    end
    if ~isempty( xLabelCEL{nPLOT} )
        xlabel( xLabelCEL{nPLOT}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
    end
    if ~isempty( yLabelCEL{nPLOT} )
        ylabel( yLabelCEL{nPLOT}, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size,'FontWeight',PlotOpt.Font_Weight);
    end
if ~isempty( legendCEL{nPLOT} )
    NonPlotDim = find( length(x) ~= size(y) );
    if isempty( NonPlotDim )
        LegLOOP = 1;
    else
        LegLOOP = size(y,NonPlotDim);
    end
    for nLOOP = 1 : LegLOOP
        [leg_h, obj_h, plot_h, LegSTR] = legend(gca);
        LegSTR{end+1} = legendCEL{nPLOT};
        legend(gca, LegSTR, 'FontName',PlotOpt.Font_Name,'FontSize',PlotOpt.Font_Size_Leg,'FontWeight',PlotOpt.Font_Weight, 'Location','Best');
    end
end
%%##############################################
end

%% TEST
if (0)

end