function [ xVEC  xVEC_IDX  xVEC_count  xVEC_IDXcel  xVEC_NUM ] = MatRowCondens( ...
    yVEC, fSymVEC, Opt_Algorith)
% calls Buss_fmBasis_Func
%-------------------------
% yVEC: being Condensed
%-------------------------
%xVEC:          distinct-row found in yVEC
%xVEC_IDX:      ROW_idx of 1ST-distinct-row found in yVEC (ptr -> yVEC=OLD)
%xVEC_count:    # of each-distinct-row found in yVEC
%xVEC_IDXcel:   ROW_idx of ALL-distinct-row found in yVEC (ptr -> yVEC=OLD)
if isempty(yVEC)
    xVEC        = [];
    xVEC_NUM    = [];
    xVEC_IDX    = [];
    xVEC_count  = [];
    xVEC_IDXcel = [];
    return
end
if ~exist('Opt_Algorith','var')
    Opt_Algorith = 'SMART';
end

if isa(yVEC, 'sym')% SYMBOLS
    if exist('fSymVEC','var')% MTone MixVector
        fNumVEC = FmixVec_SubsFunc( fSymVEC );
    else% Multiplicative Terms
        fSymVEC = sym(findsym( yVEC ));
        fNumVEC = PrimesVec(length( fSymVEC ));
    end
 	yVEC_NUM = single(subs(yVEC, fSymVEC,fNumVEC)); %sym(findsym(y)), {100,101}
else% NUMERIC
    yVEC_NUM = yVEC;
end

xVEC_NUM    = [];
xVEC_IDX    = [];
xVEC_count  = [];
xVEC_IDXcel = {};
switch Opt_Algorith
%% ##########################
    case {'SMART'}
yVEC_IDX = [1 : size(yVEC,1)].';
while ~isempty( yVEC_NUM )
	[flagISFOUND	x_IDX	xXORy_IDX ] = Find_ElemIDX( yVEC_NUM, yVEC_NUM(1,:), 'NOT_symSUBnum');
	%[flagISFOUND	x_IDX_	xXORy_IDX_] = Buss_fmBasis_Func( yVEC_NUM, yVEC_NUM(1,:), 'fm_idx');
    %if (~isequal( x_IDX,   	x_IDX_ ) || ~isequal( xXORy_IDX,	xXORy_IDX_ ))
    %    disp('ERROR MatRowCondens: Buss_fmBasis != Find_ElemIDX');
    %end
    %disp('%########################');
   	%x_IDX% DEBUG
    %xXORy_IDX% DEBUG
    %yVEC_IDX(x_IDX)% DEBUG
    %yVEC_NUM(x_IDX,:)% DEBUG
    	xVEC_NUM	= [xVEC_NUM;    yVEC_NUM( x_IDX(1), :)];% ROW stack
     	xVEC_IDX    = [xVEC_IDX;    yVEC_IDX( x_IDX(1)   )];
        xVEC_count  = [xVEC_count;  length( x_IDX )];
        xVEC_IDXcel{ length(xVEC_IDX),1 } = yVEC_IDX( x_IDX );
    %disp('%############');
   	%xXORy_IDX% DEBUG
    %yVEC_IDX(xXORy_IDX,:)% DEBUG
    %yVEC_NUM(xXORy_IDX,:)% DEBUG
        yVEC_IDX    = yVEC_IDX( xXORy_IDX, :);
        yVEC_NUM    = yVEC_NUM( xXORy_IDX, :);
end
%% ##########################
    case {'DUMB'}
for n = 1 : size(yVEC,1)
	[flagISFOUND	x_IDX ] = Find_ElemIDX( xVEC_NUM, yVEC_NUM(n,:), 'NOT_symSUBnum');
	%[flagISFOUND	x_IDX_] = Buss_fmBasis_Func( xVEC_NUM, yVEC_NUM(n,:), 'fm_idx');
    %if (~isequal( x_IDX,   	x_IDX_ ))
    %    disp('ERROR MatRowCondens: Buss_fmBasis != Find_ElemIDX');
    %end
    %n% DEBUG
    %x_IDX% DEBUG
	if(flagISFOUND == 0)
    	xVEC_NUM	= [xVEC_NUM;    yVEC_NUM(n,:)];
     	xVEC_IDX    = [xVEC_IDX;    n];
        xVEC_count  = [xVEC_count;  1];
    else
     	%xVEC_IDX(x_IDX,:)	= [[xVEC_IDX(x_IDX,:)]	n];% DONT WORK
        xVEC_count(x_IDX)   = xVEC_count(x_IDX)     +1;
  	end
end
%% ##########################
end

if isa(yVEC, 'sym')
    xVEC = yVEC( xVEC_IDX(:,1),:);
else
    xVEC = xVEC_NUM;
end

%% Test
if(0)
    
yVEC = [[  ((f1)),  ((f1)), ((-f1)), ((-f1))];...
    [  ((f1)), ((-f1)), ((-f1)),  ((f1))];...
    [  ((f1)), ((-f1)), ((-f1)),  ((f1))];...
    [  ((f1)), ((-f1)), ((-f1)),  ((f1))];...
    [  ((f1)), ((-f1)), ((-f1)),  ((f1))];...
    [ ((-f1)), ((-f1)),  ((f1)),  ((f1))]]
[xVEC, xVEC_IDX, xVEC_count] = MatRowCondens(yVEC, fSymVEC)
    
end
